/* graph-stacked-renderer.c generated by valac 0.56.3, the Vala compiler
 * generated from graph-stacked-renderer.vala, do not modify */

/* graph-stacked-renderer.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <dazzle.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_GRAPH_STACKED_RENDERER (usage_graph_stacked_renderer_get_type ())
#define USAGE_GRAPH_STACKED_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer))
#define USAGE_GRAPH_STACKED_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRendererClass))
#define USAGE_IS_GRAPH_STACKED_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_GRAPH_STACKED_RENDERER))
#define USAGE_IS_GRAPH_STACKED_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_GRAPH_STACKED_RENDERER))
#define USAGE_GRAPH_STACKED_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRendererClass))

typedef struct _UsageGraphStackedRenderer UsageGraphStackedRenderer;
typedef struct _UsageGraphStackedRendererClass UsageGraphStackedRendererClass;
typedef struct _UsageGraphStackedRendererPrivate UsageGraphStackedRendererPrivate;
enum  {
	USAGE_GRAPH_STACKED_RENDERER_0_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_NUM_PROPERTIES
};
static GParamSpec* usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_NUM_PROPERTIES];

struct _UsageGraphStackedRenderer {
	GObject parent_instance;
	UsageGraphStackedRendererPrivate * priv;
};

struct _UsageGraphStackedRendererClass {
	GObjectClass parent_class;
};

struct _UsageGraphStackedRendererPrivate {
	guint _column;
	gdouble _line_width;
	GdkRGBA _stroke_color_rgba;
	GdkRGBA _stacked_color_rgba;
};

static gint UsageGraphStackedRenderer_private_offset;
static gpointer usage_graph_stacked_renderer_parent_class = NULL;
static DzlGraphRendererInterface * usage_graph_stacked_renderer_dzl_graph_view_renderer_parent_iface = NULL;

VALA_EXTERN GType usage_graph_stacked_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageGraphStackedRenderer, g_object_unref)
static void usage_graph_stacked_renderer_real_render (DzlGraphRenderer* base,
                                               DzlGraphModel* model,
                                               gint64 x_begin,
                                               gint64 x_end,
                                               gdouble y_begin,
                                               gdouble y_end,
                                               cairo_t* cr,
                                               cairo_rectangle_int_t* area);
static gdouble usage_graph_stacked_renderer_calc_x (DzlGraphModelIter* iter,
                                             gint64 begin,
                                             gint64 end,
                                             guint width);
static gdouble usage_graph_stacked_renderer_calc_y (DzlGraphModelIter* iter,
                                             gdouble range_begin,
                                             gdouble range_end,
                                             guint height,
                                             guint column);
VALA_EXTERN guint usage_graph_stacked_renderer_get_column (UsageGraphStackedRenderer* self);
VALA_EXTERN gdouble usage_graph_stacked_renderer_get_line_width (UsageGraphStackedRenderer* self);
VALA_EXTERN void usage_graph_stacked_renderer_get_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                          GdkRGBA * result);
VALA_EXTERN void usage_graph_stacked_renderer_get_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                         GdkRGBA * result);
VALA_EXTERN UsageGraphStackedRenderer* usage_graph_stacked_renderer_new (void);
VALA_EXTERN UsageGraphStackedRenderer* usage_graph_stacked_renderer_construct (GType object_type);
VALA_EXTERN void usage_graph_stacked_renderer_set_column (UsageGraphStackedRenderer* self,
                                              guint value);
VALA_EXTERN void usage_graph_stacked_renderer_set_line_width (UsageGraphStackedRenderer* self,
                                                  gdouble value);
VALA_EXTERN void usage_graph_stacked_renderer_set_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                         GdkRGBA * value);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
VALA_EXTERN void usage_graph_stacked_renderer_set_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                          GdkRGBA * value);
static void usage_graph_stacked_renderer_finalize (GObject * obj);
static GType usage_graph_stacked_renderer_get_type_once (void);
static void _vala_usage_graph_stacked_renderer_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_usage_graph_stacked_renderer_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
usage_graph_stacked_renderer_get_instance_private (UsageGraphStackedRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, UsageGraphStackedRenderer_private_offset);
}

static void
usage_graph_stacked_renderer_real_render (DzlGraphRenderer* base,
                                          DzlGraphModel* model,
                                          gint64 x_begin,
                                          gint64 x_end,
                                          gdouble y_begin,
                                          gdouble y_end,
                                          cairo_t* cr,
                                          cairo_rectangle_int_t* area)
{
	UsageGraphStackedRenderer * self;
	DzlGraphModelIter iter = {0};
	DzlGraphModelIter _tmp0_ = {0};
	gboolean _tmp1_;
	gdouble _tmp15_;
	GdkRGBA _tmp16_;
	GdkRGBA _tmp17_;
	GdkRGBA _tmp18_;
	GdkRGBA _tmp19_;
	cairo_rectangle_int_t _tmp20_;
	DzlGraphModelIter _tmp21_ = {0};
	gboolean _tmp22_;
	GdkRGBA _tmp35_;
	GdkRGBA _tmp36_;
	GdkRGBA _tmp37_;
	GdkRGBA _tmp38_;
#line 33 "../src/graph-stacked-renderer.vala"
	self = (UsageGraphStackedRenderer*) base;
#line 33 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (model != NULL);
#line 33 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (cr != NULL);
#line 33 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (area != NULL);
#line 35 "../src/graph-stacked-renderer.vala"
	cairo_save (cr);
#line 37 "../src/graph-stacked-renderer.vala"
	_tmp1_ = dzl_graph_view_model_get_iter_first (model, &_tmp0_);
#line 37 "../src/graph-stacked-renderer.vala"
	iter = _tmp0_;
#line 37 "../src/graph-stacked-renderer.vala"
	if (_tmp1_) {
#line 182 "graph-stacked-renderer.c"
		gdouble chunk = 0.0;
		cairo_rectangle_int_t _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		gdouble last_x = 0.0;
		DzlGraphModelIter _tmp5_;
		cairo_rectangle_int_t _tmp6_;
		gdouble last_y = 0.0;
		cairo_rectangle_int_t _tmp7_;
		cairo_rectangle_int_t _tmp8_;
#line 38 "../src/graph-stacked-renderer.vala"
		_tmp2_ = *area;
#line 38 "../src/graph-stacked-renderer.vala"
		_tmp3_ = dzl_graph_view_model_get_max_samples (model);
#line 38 "../src/graph-stacked-renderer.vala"
		_tmp4_ = _tmp3_;
#line 38 "../src/graph-stacked-renderer.vala"
		chunk = (_tmp2_.width / ((gdouble) (_tmp4_ - 1))) / 2.0;
#line 39 "../src/graph-stacked-renderer.vala"
		_tmp5_ = iter;
#line 39 "../src/graph-stacked-renderer.vala"
		_tmp6_ = *area;
#line 39 "../src/graph-stacked-renderer.vala"
		last_x = usage_graph_stacked_renderer_calc_x (&_tmp5_, x_begin, x_end, (guint) _tmp6_.width);
#line 40 "../src/graph-stacked-renderer.vala"
		_tmp7_ = *area;
#line 40 "../src/graph-stacked-renderer.vala"
		last_y = (gdouble) _tmp7_.height;
#line 42 "../src/graph-stacked-renderer.vala"
		_tmp8_ = *area;
#line 42 "../src/graph-stacked-renderer.vala"
		cairo_move_to (cr, last_x, (gdouble) _tmp8_.height);
#line 44 "../src/graph-stacked-renderer.vala"
		while (TRUE) {
#line 217 "graph-stacked-renderer.c"
			gboolean _tmp9_;
			gdouble x = 0.0;
			DzlGraphModelIter _tmp10_;
			cairo_rectangle_int_t _tmp11_;
			gdouble y = 0.0;
			DzlGraphModelIter _tmp12_;
			cairo_rectangle_int_t _tmp13_;
			guint _tmp14_;
#line 44 "../src/graph-stacked-renderer.vala"
			_tmp9_ = dzl_graph_view_model_iter_next (&iter);
#line 44 "../src/graph-stacked-renderer.vala"
			if (!_tmp9_) {
#line 44 "../src/graph-stacked-renderer.vala"
				break;
#line 232 "graph-stacked-renderer.c"
			}
#line 46 "../src/graph-stacked-renderer.vala"
			_tmp10_ = iter;
#line 46 "../src/graph-stacked-renderer.vala"
			_tmp11_ = *area;
#line 46 "../src/graph-stacked-renderer.vala"
			x = usage_graph_stacked_renderer_calc_x (&_tmp10_, x_begin, x_end, (guint) _tmp11_.width);
#line 47 "../src/graph-stacked-renderer.vala"
			_tmp12_ = iter;
#line 47 "../src/graph-stacked-renderer.vala"
			_tmp13_ = *area;
#line 47 "../src/graph-stacked-renderer.vala"
			_tmp14_ = self->priv->_column;
#line 47 "../src/graph-stacked-renderer.vala"
			y = usage_graph_stacked_renderer_calc_y (&_tmp12_, y_begin, y_end, (guint) _tmp13_.height, _tmp14_);
#line 49 "../src/graph-stacked-renderer.vala"
			cairo_curve_to (cr, last_x + chunk, last_y, last_x + chunk, y, x, y);
#line 51 "../src/graph-stacked-renderer.vala"
			last_x = x;
#line 52 "../src/graph-stacked-renderer.vala"
			last_y = y;
#line 254 "graph-stacked-renderer.c"
		}
	}
#line 56 "../src/graph-stacked-renderer.vala"
	_tmp15_ = self->priv->_line_width;
#line 56 "../src/graph-stacked-renderer.vala"
	cairo_set_line_width (cr, _tmp15_);
#line 57 "../src/graph-stacked-renderer.vala"
	_tmp16_ = self->priv->_stacked_color_rgba;
#line 57 "../src/graph-stacked-renderer.vala"
	_tmp17_ = self->priv->_stacked_color_rgba;
#line 57 "../src/graph-stacked-renderer.vala"
	_tmp18_ = self->priv->_stacked_color_rgba;
#line 57 "../src/graph-stacked-renderer.vala"
	_tmp19_ = self->priv->_stacked_color_rgba;
#line 57 "../src/graph-stacked-renderer.vala"
	cairo_set_source_rgba (cr, _tmp16_.red, _tmp17_.green, _tmp18_.blue, _tmp19_.alpha);
#line 58 "../src/graph-stacked-renderer.vala"
	_tmp20_ = *area;
#line 58 "../src/graph-stacked-renderer.vala"
	cairo_rel_line_to (cr, (gdouble) 0, (gdouble) _tmp20_.height);
#line 59 "../src/graph-stacked-renderer.vala"
	cairo_stroke_preserve (cr);
#line 60 "../src/graph-stacked-renderer.vala"
	cairo_close_path (cr);
#line 61 "../src/graph-stacked-renderer.vala"
	cairo_fill (cr);
#line 63 "../src/graph-stacked-renderer.vala"
	_tmp22_ = dzl_graph_view_model_get_iter_first (model, &_tmp21_);
#line 63 "../src/graph-stacked-renderer.vala"
	iter = _tmp21_;
#line 63 "../src/graph-stacked-renderer.vala"
	if (_tmp22_) {
#line 287 "graph-stacked-renderer.c"
		gdouble chunk = 0.0;
		cairo_rectangle_int_t _tmp23_;
		guint _tmp24_;
		guint _tmp25_;
		gdouble last_x = 0.0;
		DzlGraphModelIter _tmp26_;
		cairo_rectangle_int_t _tmp27_;
		gdouble last_y = 0.0;
		cairo_rectangle_int_t _tmp28_;
#line 64 "../src/graph-stacked-renderer.vala"
		_tmp23_ = *area;
#line 64 "../src/graph-stacked-renderer.vala"
		_tmp24_ = dzl_graph_view_model_get_max_samples (model);
#line 64 "../src/graph-stacked-renderer.vala"
		_tmp25_ = _tmp24_;
#line 64 "../src/graph-stacked-renderer.vala"
		chunk = (_tmp23_.width / ((gdouble) (_tmp25_ - 1))) / 2.0;
#line 65 "../src/graph-stacked-renderer.vala"
		_tmp26_ = iter;
#line 65 "../src/graph-stacked-renderer.vala"
		_tmp27_ = *area;
#line 65 "../src/graph-stacked-renderer.vala"
		last_x = usage_graph_stacked_renderer_calc_x (&_tmp26_, x_begin, x_end, (guint) _tmp27_.width);
#line 66 "../src/graph-stacked-renderer.vala"
		_tmp28_ = *area;
#line 66 "../src/graph-stacked-renderer.vala"
		last_y = (gdouble) _tmp28_.height;
#line 68 "../src/graph-stacked-renderer.vala"
		cairo_move_to (cr, last_x, last_y);
#line 70 "../src/graph-stacked-renderer.vala"
		while (TRUE) {
#line 319 "graph-stacked-renderer.c"
			gboolean _tmp29_;
			gdouble x = 0.0;
			DzlGraphModelIter _tmp30_;
			cairo_rectangle_int_t _tmp31_;
			gdouble y = 0.0;
			DzlGraphModelIter _tmp32_;
			cairo_rectangle_int_t _tmp33_;
			guint _tmp34_;
#line 70 "../src/graph-stacked-renderer.vala"
			_tmp29_ = dzl_graph_view_model_iter_next (&iter);
#line 70 "../src/graph-stacked-renderer.vala"
			if (!_tmp29_) {
#line 70 "../src/graph-stacked-renderer.vala"
				break;
#line 334 "graph-stacked-renderer.c"
			}
#line 72 "../src/graph-stacked-renderer.vala"
			_tmp30_ = iter;
#line 72 "../src/graph-stacked-renderer.vala"
			_tmp31_ = *area;
#line 72 "../src/graph-stacked-renderer.vala"
			x = usage_graph_stacked_renderer_calc_x (&_tmp30_, x_begin, x_end, (guint) _tmp31_.width);
#line 73 "../src/graph-stacked-renderer.vala"
			_tmp32_ = iter;
#line 73 "../src/graph-stacked-renderer.vala"
			_tmp33_ = *area;
#line 73 "../src/graph-stacked-renderer.vala"
			_tmp34_ = self->priv->_column;
#line 73 "../src/graph-stacked-renderer.vala"
			y = usage_graph_stacked_renderer_calc_y (&_tmp32_, y_begin, y_end, (guint) _tmp33_.height, _tmp34_);
#line 75 "../src/graph-stacked-renderer.vala"
			cairo_curve_to (cr, last_x + chunk, last_y, last_x + chunk, y, x, y);
#line 77 "../src/graph-stacked-renderer.vala"
			last_x = x;
#line 78 "../src/graph-stacked-renderer.vala"
			last_y = y;
#line 356 "graph-stacked-renderer.c"
		}
	}
#line 82 "../src/graph-stacked-renderer.vala"
	_tmp35_ = self->priv->_stroke_color_rgba;
#line 82 "../src/graph-stacked-renderer.vala"
	_tmp36_ = self->priv->_stroke_color_rgba;
#line 82 "../src/graph-stacked-renderer.vala"
	_tmp37_ = self->priv->_stroke_color_rgba;
#line 82 "../src/graph-stacked-renderer.vala"
	_tmp38_ = self->priv->_stacked_color_rgba;
#line 82 "../src/graph-stacked-renderer.vala"
	cairo_set_source_rgba (cr, _tmp35_.red, _tmp36_.green, _tmp37_.blue, _tmp38_.alpha);
#line 83 "../src/graph-stacked-renderer.vala"
	cairo_stroke (cr);
#line 84 "../src/graph-stacked-renderer.vala"
	cairo_restore (cr);
#line 373 "graph-stacked-renderer.c"
}

static gdouble
usage_graph_stacked_renderer_calc_x (DzlGraphModelIter* iter,
                                     gint64 begin,
                                     gint64 end,
                                     guint width)
{
	gint64 timestamp = 0LL;
	DzlGraphModelIter _tmp0_;
	gdouble result;
#line 87 "../src/graph-stacked-renderer.vala"
	g_return_val_if_fail (iter != NULL, 0.0);
#line 88 "../src/graph-stacked-renderer.vala"
	_tmp0_ = *iter;
#line 88 "../src/graph-stacked-renderer.vala"
	timestamp = dzl_graph_view_model_iter_get_timestamp (&_tmp0_);
#line 90 "../src/graph-stacked-renderer.vala"
	result = ((timestamp - begin) / ((gdouble) (end - begin))) * width;
#line 90 "../src/graph-stacked-renderer.vala"
	return result;
#line 395 "graph-stacked-renderer.c"
}

static gdouble
usage_graph_stacked_renderer_calc_y (DzlGraphModelIter* iter,
                                     gdouble range_begin,
                                     gdouble range_end,
                                     guint height,
                                     guint column)
{
	gdouble y = 0.0;
	GValue val = {0};
	DzlGraphModelIter _tmp0_;
	GValue _tmp1_ = {0};
	gdouble result;
#line 93 "../src/graph-stacked-renderer.vala"
	g_return_val_if_fail (iter != NULL, 0.0);
#line 96 "../src/graph-stacked-renderer.vala"
	_tmp0_ = *iter;
#line 96 "../src/graph-stacked-renderer.vala"
	dzl_graph_view_model_iter_get_value (&_tmp0_, column, &_tmp1_);
#line 96 "../src/graph-stacked-renderer.vala"
	val = _tmp1_;
#line 97 "../src/graph-stacked-renderer.vala"
	switch (G_VALUE_TYPE (&val)) {
#line 97 "../src/graph-stacked-renderer.vala"
		case G_TYPE_DOUBLE:
#line 422 "graph-stacked-renderer.c"
		{
#line 100 "../src/graph-stacked-renderer.vala"
			y = g_value_get_double (&val);
#line 101 "../src/graph-stacked-renderer.vala"
			break;
#line 428 "graph-stacked-renderer.c"
		}
#line 97 "../src/graph-stacked-renderer.vala"
		case G_TYPE_UINT:
#line 432 "graph-stacked-renderer.c"
		{
#line 103 "../src/graph-stacked-renderer.vala"
			y = (gdouble) g_value_get_uint (&val);
#line 104 "../src/graph-stacked-renderer.vala"
			break;
#line 438 "graph-stacked-renderer.c"
		}
#line 97 "../src/graph-stacked-renderer.vala"
		case G_TYPE_UINT64:
#line 442 "graph-stacked-renderer.c"
		{
#line 106 "../src/graph-stacked-renderer.vala"
			y = (gdouble) g_value_get_uint64 (&val);
#line 107 "../src/graph-stacked-renderer.vala"
			break;
#line 448 "graph-stacked-renderer.c"
		}
#line 97 "../src/graph-stacked-renderer.vala"
		case G_TYPE_INT:
#line 452 "graph-stacked-renderer.c"
		{
#line 109 "../src/graph-stacked-renderer.vala"
			y = (gdouble) g_value_get_int (&val);
#line 110 "../src/graph-stacked-renderer.vala"
			break;
#line 458 "graph-stacked-renderer.c"
		}
#line 97 "../src/graph-stacked-renderer.vala"
		case G_TYPE_INT64:
#line 462 "graph-stacked-renderer.c"
		{
#line 112 "../src/graph-stacked-renderer.vala"
			y = (gdouble) g_value_get_int64 (&val);
#line 113 "../src/graph-stacked-renderer.vala"
			break;
#line 468 "graph-stacked-renderer.c"
		}
		default:
		{
#line 115 "../src/graph-stacked-renderer.vala"
			y = 0.0;
#line 116 "../src/graph-stacked-renderer.vala"
			break;
#line 476 "graph-stacked-renderer.c"
		}
	}
#line 119 "../src/graph-stacked-renderer.vala"
	y -= range_begin;
#line 120 "../src/graph-stacked-renderer.vala"
	y /= range_end - range_begin;
#line 121 "../src/graph-stacked-renderer.vala"
	y = height - (y * height);
#line 123 "../src/graph-stacked-renderer.vala"
	result = y;
#line 123 "../src/graph-stacked-renderer.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 123 "../src/graph-stacked-renderer.vala"
	return result;
#line 491 "graph-stacked-renderer.c"
}

UsageGraphStackedRenderer*
usage_graph_stacked_renderer_construct (GType object_type)
{
	UsageGraphStackedRenderer * self = NULL;
#line 26 "../src/graph-stacked-renderer.vala"
	self = (UsageGraphStackedRenderer*) g_object_new (object_type, NULL);
#line 26 "../src/graph-stacked-renderer.vala"
	return self;
#line 502 "graph-stacked-renderer.c"
}

UsageGraphStackedRenderer*
usage_graph_stacked_renderer_new (void)
{
#line 26 "../src/graph-stacked-renderer.vala"
	return usage_graph_stacked_renderer_construct (USAGE_TYPE_GRAPH_STACKED_RENDERER);
#line 510 "graph-stacked-renderer.c"
}

guint
usage_graph_stacked_renderer_get_column (UsageGraphStackedRenderer* self)
{
	guint result;
#line 28 "../src/graph-stacked-renderer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 28 "../src/graph-stacked-renderer.vala"
	result = self->priv->_column;
#line 28 "../src/graph-stacked-renderer.vala"
	return result;
#line 523 "graph-stacked-renderer.c"
}

void
usage_graph_stacked_renderer_set_column (UsageGraphStackedRenderer* self,
                                         guint value)
{
	guint old_value;
#line 28 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/graph-stacked-renderer.vala"
	old_value = usage_graph_stacked_renderer_get_column (self);
#line 28 "../src/graph-stacked-renderer.vala"
	if (old_value != value) {
#line 28 "../src/graph-stacked-renderer.vala"
		self->priv->_column = value;
#line 28 "../src/graph-stacked-renderer.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY]);
#line 541 "graph-stacked-renderer.c"
	}
}

gdouble
usage_graph_stacked_renderer_get_line_width (UsageGraphStackedRenderer* self)
{
	gdouble result;
#line 29 "../src/graph-stacked-renderer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 29 "../src/graph-stacked-renderer.vala"
	result = self->priv->_line_width;
#line 29 "../src/graph-stacked-renderer.vala"
	return result;
#line 555 "graph-stacked-renderer.c"
}

void
usage_graph_stacked_renderer_set_line_width (UsageGraphStackedRenderer* self,
                                             gdouble value)
{
	gdouble old_value;
#line 29 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/graph-stacked-renderer.vala"
	old_value = usage_graph_stacked_renderer_get_line_width (self);
#line 29 "../src/graph-stacked-renderer.vala"
	if (old_value != value) {
#line 29 "../src/graph-stacked-renderer.vala"
		self->priv->_line_width = value;
#line 29 "../src/graph-stacked-renderer.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY]);
#line 573 "graph-stacked-renderer.c"
	}
}

void
usage_graph_stacked_renderer_get_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                    GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 30 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/graph-stacked-renderer.vala"
	_tmp0_ = self->priv->_stroke_color_rgba;
#line 30 "../src/graph-stacked-renderer.vala"
	*result = _tmp0_;
#line 30 "../src/graph-stacked-renderer.vala"
	return;
#line 590 "graph-stacked-renderer.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 30 "../src/graph-stacked-renderer.vala"
	if (s1 == s2) {
#line 30 "../src/graph-stacked-renderer.vala"
		return TRUE;
#line 601 "graph-stacked-renderer.c"
	}
#line 30 "../src/graph-stacked-renderer.vala"
	if (s1 == NULL) {
#line 30 "../src/graph-stacked-renderer.vala"
		return FALSE;
#line 607 "graph-stacked-renderer.c"
	}
#line 30 "../src/graph-stacked-renderer.vala"
	if (s2 == NULL) {
#line 30 "../src/graph-stacked-renderer.vala"
		return FALSE;
#line 613 "graph-stacked-renderer.c"
	}
#line 30 "../src/graph-stacked-renderer.vala"
	if (s1->red != s2->red) {
#line 30 "../src/graph-stacked-renderer.vala"
		return FALSE;
#line 619 "graph-stacked-renderer.c"
	}
#line 30 "../src/graph-stacked-renderer.vala"
	if (s1->green != s2->green) {
#line 30 "../src/graph-stacked-renderer.vala"
		return FALSE;
#line 625 "graph-stacked-renderer.c"
	}
#line 30 "../src/graph-stacked-renderer.vala"
	if (s1->blue != s2->blue) {
#line 30 "../src/graph-stacked-renderer.vala"
		return FALSE;
#line 631 "graph-stacked-renderer.c"
	}
#line 30 "../src/graph-stacked-renderer.vala"
	if (s1->alpha != s2->alpha) {
#line 30 "../src/graph-stacked-renderer.vala"
		return FALSE;
#line 637 "graph-stacked-renderer.c"
	}
#line 30 "../src/graph-stacked-renderer.vala"
	return TRUE;
#line 641 "graph-stacked-renderer.c"
}

void
usage_graph_stacked_renderer_set_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                    GdkRGBA * value)
{
	GdkRGBA old_value;
#line 30 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/graph-stacked-renderer.vala"
	usage_graph_stacked_renderer_get_stroke_color_rgba (self, &old_value);
#line 30 "../src/graph-stacked-renderer.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 655 "graph-stacked-renderer.c"
		GdkRGBA _tmp0_;
#line 30 "../src/graph-stacked-renderer.vala"
		_tmp0_ = *value;
#line 30 "../src/graph-stacked-renderer.vala"
		self->priv->_stroke_color_rgba = _tmp0_;
#line 30 "../src/graph-stacked-renderer.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY]);
#line 663 "graph-stacked-renderer.c"
	}
}

void
usage_graph_stacked_renderer_get_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                     GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 31 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/graph-stacked-renderer.vala"
	_tmp0_ = self->priv->_stacked_color_rgba;
#line 31 "../src/graph-stacked-renderer.vala"
	*result = _tmp0_;
#line 31 "../src/graph-stacked-renderer.vala"
	return;
#line 680 "graph-stacked-renderer.c"
}

void
usage_graph_stacked_renderer_set_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                     GdkRGBA * value)
{
	GdkRGBA old_value;
#line 31 "../src/graph-stacked-renderer.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/graph-stacked-renderer.vala"
	usage_graph_stacked_renderer_get_stacked_color_rgba (self, &old_value);
#line 31 "../src/graph-stacked-renderer.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 694 "graph-stacked-renderer.c"
		GdkRGBA _tmp0_;
#line 31 "../src/graph-stacked-renderer.vala"
		_tmp0_ = *value;
#line 31 "../src/graph-stacked-renderer.vala"
		self->priv->_stacked_color_rgba = _tmp0_;
#line 31 "../src/graph-stacked-renderer.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY]);
#line 702 "graph-stacked-renderer.c"
	}
}

static void
usage_graph_stacked_renderer_class_init (UsageGraphStackedRendererClass * klass,
                                         gpointer klass_data)
{
#line 26 "../src/graph-stacked-renderer.vala"
	usage_graph_stacked_renderer_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/graph-stacked-renderer.vala"
	g_type_class_adjust_private_offset (klass, &UsageGraphStackedRenderer_private_offset);
#line 26 "../src/graph-stacked-renderer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_graph_stacked_renderer_get_property;
#line 26 "../src/graph-stacked-renderer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_graph_stacked_renderer_set_property;
#line 26 "../src/graph-stacked-renderer.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_graph_stacked_renderer_finalize;
#line 26 "../src/graph-stacked-renderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY] = g_param_spec_uint ("column", "column", "column", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/graph-stacked-renderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY] = g_param_spec_double ("line-width", "line-width", "line-width", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/graph-stacked-renderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY] = g_param_spec_boxed ("stroke-color-rgba", "stroke-color-rgba", "stroke-color-rgba", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/graph-stacked-renderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY] = g_param_spec_boxed ("stacked-color-rgba", "stacked-color-rgba", "stacked-color-rgba", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 728 "graph-stacked-renderer.c"
}

static void
usage_graph_stacked_renderer_dzl_graph_view_renderer_interface_init (DzlGraphRendererInterface * iface,
                                                                     gpointer iface_data)
{
#line 26 "../src/graph-stacked-renderer.vala"
	usage_graph_stacked_renderer_dzl_graph_view_renderer_parent_iface = g_type_interface_peek_parent (iface);
#line 26 "../src/graph-stacked-renderer.vala"
	iface->render = (void (*) (DzlGraphRenderer*, DzlGraphModel*, gint64, gint64, gdouble, gdouble, cairo_t*, cairo_rectangle_int_t*)) usage_graph_stacked_renderer_real_render;
#line 739 "graph-stacked-renderer.c"
}

static void
usage_graph_stacked_renderer_instance_init (UsageGraphStackedRenderer * self,
                                            gpointer klass)
{
#line 26 "../src/graph-stacked-renderer.vala"
	self->priv = usage_graph_stacked_renderer_get_instance_private (self);
#line 29 "../src/graph-stacked-renderer.vala"
	self->priv->_line_width = 1.0;
#line 750 "graph-stacked-renderer.c"
}

static void
usage_graph_stacked_renderer_finalize (GObject * obj)
{
	UsageGraphStackedRenderer * self;
#line 26 "../src/graph-stacked-renderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer);
#line 26 "../src/graph-stacked-renderer.vala"
	G_OBJECT_CLASS (usage_graph_stacked_renderer_parent_class)->finalize (obj);
#line 761 "graph-stacked-renderer.c"
}

static GType
usage_graph_stacked_renderer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageGraphStackedRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_graph_stacked_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageGraphStackedRenderer), 0, (GInstanceInitFunc) usage_graph_stacked_renderer_instance_init, NULL };
	static const GInterfaceInfo dzl_graph_view_renderer_info = { (GInterfaceInitFunc) usage_graph_stacked_renderer_dzl_graph_view_renderer_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType usage_graph_stacked_renderer_type_id;
	usage_graph_stacked_renderer_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageGraphStackedRenderer", &g_define_type_info, 0);
	g_type_add_interface_static (usage_graph_stacked_renderer_type_id, dzl_graph_view_renderer_get_type (), &dzl_graph_view_renderer_info);
	UsageGraphStackedRenderer_private_offset = g_type_add_instance_private (usage_graph_stacked_renderer_type_id, sizeof (UsageGraphStackedRendererPrivate));
	return usage_graph_stacked_renderer_type_id;
}

GType
usage_graph_stacked_renderer_get_type (void)
{
	static volatile gsize usage_graph_stacked_renderer_type_id__once = 0;
	if (g_once_init_enter (&usage_graph_stacked_renderer_type_id__once)) {
		GType usage_graph_stacked_renderer_type_id;
		usage_graph_stacked_renderer_type_id = usage_graph_stacked_renderer_get_type_once ();
		g_once_init_leave (&usage_graph_stacked_renderer_type_id__once, usage_graph_stacked_renderer_type_id);
	}
	return usage_graph_stacked_renderer_type_id__once;
}

static void
_vala_usage_graph_stacked_renderer_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	UsageGraphStackedRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer);
#line 26 "../src/graph-stacked-renderer.vala"
	switch (property_id) {
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY:
#line 26 "../src/graph-stacked-renderer.vala"
		g_value_set_uint (value, usage_graph_stacked_renderer_get_column (self));
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY:
#line 26 "../src/graph-stacked-renderer.vala"
		g_value_set_double (value, usage_graph_stacked_renderer_get_line_width (self));
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY:
#line 812 "graph-stacked-renderer.c"
		{
			GdkRGBA boxed;
#line 26 "../src/graph-stacked-renderer.vala"
			usage_graph_stacked_renderer_get_stroke_color_rgba (self, &boxed);
#line 26 "../src/graph-stacked-renderer.vala"
			g_value_set_boxed (value, &boxed);
#line 819 "graph-stacked-renderer.c"
		}
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY:
#line 825 "graph-stacked-renderer.c"
		{
			GdkRGBA boxed;
#line 26 "../src/graph-stacked-renderer.vala"
			usage_graph_stacked_renderer_get_stacked_color_rgba (self, &boxed);
#line 26 "../src/graph-stacked-renderer.vala"
			g_value_set_boxed (value, &boxed);
#line 832 "graph-stacked-renderer.c"
		}
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 836 "graph-stacked-renderer.c"
		default:
#line 26 "../src/graph-stacked-renderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 842 "graph-stacked-renderer.c"
	}
}

static void
_vala_usage_graph_stacked_renderer_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	UsageGraphStackedRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer);
#line 26 "../src/graph-stacked-renderer.vala"
	switch (property_id) {
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY:
#line 26 "../src/graph-stacked-renderer.vala"
		usage_graph_stacked_renderer_set_column (self, g_value_get_uint (value));
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY:
#line 26 "../src/graph-stacked-renderer.vala"
		usage_graph_stacked_renderer_set_line_width (self, g_value_get_double (value));
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY:
#line 26 "../src/graph-stacked-renderer.vala"
		usage_graph_stacked_renderer_set_stroke_color_rgba (self, g_value_get_boxed (value));
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 26 "../src/graph-stacked-renderer.vala"
		case USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY:
#line 26 "../src/graph-stacked-renderer.vala"
		usage_graph_stacked_renderer_set_stacked_color_rgba (self, g_value_get_boxed (value));
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 880 "graph-stacked-renderer.c"
		default:
#line 26 "../src/graph-stacked-renderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/graph-stacked-renderer.vala"
		break;
#line 886 "graph-stacked-renderer.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

