/* memory-graph-model.c generated by valac 0.56.3, the Vala compiler
 * generated from memory-graph-model.vala, do not modify */

/* memory-graph-model.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <dazzle.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define USAGE_MEMORY_GRAPH_MODEL_COLUMN_RAM 0
#define USAGE_MEMORY_GRAPH_MODEL_COLUMN_SWAP 1
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_MEMORY_GRAPH_MODEL (usage_memory_graph_model_get_type ())
#define USAGE_MEMORY_GRAPH_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_MEMORY_GRAPH_MODEL, UsageMemoryGraphModel))
#define USAGE_MEMORY_GRAPH_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_MEMORY_GRAPH_MODEL, UsageMemoryGraphModelClass))
#define USAGE_IS_MEMORY_GRAPH_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_MEMORY_GRAPH_MODEL))
#define USAGE_IS_MEMORY_GRAPH_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_MEMORY_GRAPH_MODEL))
#define USAGE_MEMORY_GRAPH_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_MEMORY_GRAPH_MODEL, UsageMemoryGraphModelClass))

typedef struct _UsageMemoryGraphModel UsageMemoryGraphModel;
typedef struct _UsageMemoryGraphModelClass UsageMemoryGraphModelClass;
typedef struct _UsageMemoryGraphModelPrivate UsageMemoryGraphModelPrivate;
enum  {
	USAGE_MEMORY_GRAPH_MODEL_0_PROPERTY,
	USAGE_MEMORY_GRAPH_MODEL_NUM_PROPERTIES
};
static GParamSpec* usage_memory_graph_model_properties[USAGE_MEMORY_GRAPH_MODEL_NUM_PROPERTIES];

#define USAGE_TYPE_SETTINGS (usage_settings_get_type ())
#define USAGE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_SETTINGS, UsageSettings))
#define USAGE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_SETTINGS, UsageSettingsClass))
#define USAGE_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_SETTINGS))
#define USAGE_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_SETTINGS))
#define USAGE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_SETTINGS, UsageSettingsClass))

typedef struct _UsageSettings UsageSettings;
typedef struct _UsageSettingsClass UsageSettingsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define USAGE_TYPE_SYSTEM_MONITOR (usage_system_monitor_get_type ())
#define USAGE_SYSTEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_SYSTEM_MONITOR, UsageSystemMonitor))
#define USAGE_SYSTEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_SYSTEM_MONITOR, UsageSystemMonitorClass))
#define USAGE_IS_SYSTEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_SYSTEM_MONITOR))
#define USAGE_IS_SYSTEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_SYSTEM_MONITOR))
#define USAGE_SYSTEM_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_SYSTEM_MONITOR, UsageSystemMonitorClass))

typedef struct _UsageSystemMonitor UsageSystemMonitor;
typedef struct _UsageSystemMonitorClass UsageSystemMonitorClass;
enum  {
	USAGE_MEMORY_GRAPH_MODEL_BIG_RAM_USAGE_SIGNAL,
	USAGE_MEMORY_GRAPH_MODEL_SMALL_RAM_USAGE_SIGNAL,
	USAGE_MEMORY_GRAPH_MODEL_NUM_SIGNALS
};
static guint usage_memory_graph_model_signals[USAGE_MEMORY_GRAPH_MODEL_NUM_SIGNALS] = {0};

struct _UsageMemoryGraphModel {
	DzlGraphModel parent_instance;
	UsageMemoryGraphModelPrivate * priv;
};

struct _UsageMemoryGraphModelClass {
	DzlGraphModelClass parent_class;
};

struct _UsageMemoryGraphModelPrivate {
	gboolean change_big_ram_usage;
	gboolean change_small_ram_usage;
};

static gint UsageMemoryGraphModel_private_offset;
static gpointer usage_memory_graph_model_parent_class = NULL;

VALA_EXTERN GType usage_memory_graph_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageMemoryGraphModel, g_object_unref)
VALA_EXTERN UsageMemoryGraphModel* usage_memory_graph_model_new (void);
VALA_EXTERN UsageMemoryGraphModel* usage_memory_graph_model_construct (GType object_type);
VALA_EXTERN GType usage_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageSettings, g_object_unref)
VALA_EXTERN UsageSettings* usage_settings_get_default (void);
VALA_EXTERN guint usage_settings_get_graph_timespan (UsageSettings* self);
VALA_EXTERN guint usage_settings_get_graph_max_samples (UsageSettings* self);
VALA_EXTERN guint usage_settings_get_graph_update_interval (UsageSettings* self);
static gboolean usage_memory_graph_model_update_data (UsageMemoryGraphModel* self);
static gboolean _usage_memory_graph_model_update_data_gsource_func (gpointer self);
VALA_EXTERN GType usage_system_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageSystemMonitor, g_object_unref)
VALA_EXTERN UsageSystemMonitor* usage_system_monitor_get_default (void);
VALA_EXTERN guint64 usage_system_monitor_get_ram_total (UsageSystemMonitor* self);
VALA_EXTERN guint64 usage_system_monitor_get_ram_usage (UsageSystemMonitor* self);
VALA_EXTERN guint64 usage_system_monitor_get_swap_usage (UsageSystemMonitor* self);
VALA_EXTERN guint64 usage_system_monitor_get_swap_total (UsageSystemMonitor* self);
static void usage_memory_graph_model_finalize (GObject * obj);
static GType usage_memory_graph_model_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
usage_memory_graph_model_get_instance_private (UsageMemoryGraphModel* self)
{
	return G_STRUCT_MEMBER_P (self, UsageMemoryGraphModel_private_offset);
}

static gboolean
_usage_memory_graph_model_update_data_gsource_func (gpointer self)
{
	gboolean result;
	result = usage_memory_graph_model_update_data ((UsageMemoryGraphModel*) self);
#line 43 "../src/memory-graph-model.vala"
	return result;
#line 142 "memory-graph-model.c"
}

UsageMemoryGraphModel*
usage_memory_graph_model_construct (GType object_type)
{
	UsageMemoryGraphModel * self = NULL;
	UsageSettings* settings = NULL;
	UsageSettings* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	DzlGraphColumn* column_ram = NULL;
	DzlGraphColumn* _tmp5_;
	DzlGraphColumn* column_swap = NULL;
	DzlGraphColumn* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
#line 33 "../src/memory-graph-model.vala"
	self = (UsageMemoryGraphModel*) g_object_new (object_type, NULL);
#line 34 "../src/memory-graph-model.vala"
	_tmp0_ = usage_settings_get_default ();
#line 34 "../src/memory-graph-model.vala"
	settings = _tmp0_;
#line 35 "../src/memory-graph-model.vala"
	_tmp1_ = usage_settings_get_graph_timespan (settings);
#line 35 "../src/memory-graph-model.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/memory-graph-model.vala"
	dzl_graph_view_model_set_timespan ((DzlGraphModel*) self, (GTimeSpan) (_tmp2_ * 1000));
#line 36 "../src/memory-graph-model.vala"
	_tmp3_ = usage_settings_get_graph_max_samples (settings);
#line 36 "../src/memory-graph-model.vala"
	_tmp4_ = _tmp3_;
#line 36 "../src/memory-graph-model.vala"
	dzl_graph_view_model_set_max_samples ((DzlGraphModel*) self, _tmp4_);
#line 38 "../src/memory-graph-model.vala"
	_tmp5_ = dzl_graph_view_column_new ("RAM", g_type_from_name ("gdouble"));
#line 38 "../src/memory-graph-model.vala"
	column_ram = _tmp5_;
#line 39 "../src/memory-graph-model.vala"
	dzl_graph_view_model_add_column ((DzlGraphModel*) self, column_ram);
#line 40 "../src/memory-graph-model.vala"
	_tmp6_ = dzl_graph_view_column_new ("SWAP", g_type_from_name ("gdouble"));
#line 40 "../src/memory-graph-model.vala"
	column_swap = _tmp6_;
#line 41 "../src/memory-graph-model.vala"
	dzl_graph_view_model_add_column ((DzlGraphModel*) self, column_swap);
#line 43 "../src/memory-graph-model.vala"
	_tmp7_ = usage_settings_get_graph_update_interval (settings);
#line 43 "../src/memory-graph-model.vala"
	_tmp8_ = _tmp7_;
#line 43 "../src/memory-graph-model.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp8_, _usage_memory_graph_model_update_data_gsource_func, g_object_ref (self), g_object_unref);
#line 33 "../src/memory-graph-model.vala"
	_g_object_unref0 (column_swap);
#line 33 "../src/memory-graph-model.vala"
	_g_object_unref0 (column_ram);
#line 33 "../src/memory-graph-model.vala"
	_g_object_unref0 (settings);
#line 33 "../src/memory-graph-model.vala"
	return self;
#line 205 "memory-graph-model.c"
}

UsageMemoryGraphModel*
usage_memory_graph_model_new (void)
{
#line 33 "../src/memory-graph-model.vala"
	return usage_memory_graph_model_construct (USAGE_TYPE_MEMORY_GRAPH_MODEL);
#line 213 "memory-graph-model.c"
}

static gboolean
usage_memory_graph_model_update_data (UsageMemoryGraphModel* self)
{
	DzlGraphModelIter iter = {0};
	DzlGraphModelIter _tmp0_ = {0};
	UsageSystemMonitor* monitor = NULL;
	UsageSystemMonitor* _tmp1_;
	gdouble ram_usage = 0.0;
	UsageSystemMonitor* _tmp2_;
	guint64 _tmp3_;
	guint64 _tmp4_;
	gdouble swap_usage = 0.0;
	UsageSystemMonitor* _tmp11_;
	guint64 _tmp12_;
	guint64 _tmp13_;
	DzlGraphModelIter _tmp20_;
	GValue _tmp21_ = {0};
	DzlGraphModelIter _tmp22_;
	GValue _tmp23_ = {0};
	gboolean result;
#line 46 "../src/memory-graph-model.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/memory-graph-model.vala"
	dzl_graph_view_model_push ((DzlGraphModel*) self, &_tmp0_, g_get_monotonic_time ());
#line 48 "../src/memory-graph-model.vala"
	iter = _tmp0_;
#line 50 "../src/memory-graph-model.vala"
	_tmp1_ = usage_system_monitor_get_default ();
#line 50 "../src/memory-graph-model.vala"
	monitor = _tmp1_;
#line 51 "../src/memory-graph-model.vala"
	ram_usage = (gdouble) 0;
#line 52 "../src/memory-graph-model.vala"
	_tmp2_ = monitor;
#line 52 "../src/memory-graph-model.vala"
	_tmp3_ = usage_system_monitor_get_ram_total (_tmp2_);
#line 52 "../src/memory-graph-model.vala"
	_tmp4_ = _tmp3_;
#line 52 "../src/memory-graph-model.vala"
	if (_tmp4_ != ((guint64) 0)) {
#line 256 "memory-graph-model.c"
		UsageSystemMonitor* _tmp5_;
		guint64 _tmp6_;
		guint64 _tmp7_;
		UsageSystemMonitor* _tmp8_;
		guint64 _tmp9_;
		guint64 _tmp10_;
#line 53 "../src/memory-graph-model.vala"
		_tmp5_ = monitor;
#line 53 "../src/memory-graph-model.vala"
		_tmp6_ = usage_system_monitor_get_ram_usage (_tmp5_);
#line 53 "../src/memory-graph-model.vala"
		_tmp7_ = _tmp6_;
#line 53 "../src/memory-graph-model.vala"
		_tmp8_ = monitor;
#line 53 "../src/memory-graph-model.vala"
		_tmp9_ = usage_system_monitor_get_ram_total (_tmp8_);
#line 53 "../src/memory-graph-model.vala"
		_tmp10_ = _tmp9_;
#line 53 "../src/memory-graph-model.vala"
		ram_usage = (((gdouble) _tmp7_) / _tmp10_) * 100;
#line 277 "memory-graph-model.c"
	}
#line 55 "../src/memory-graph-model.vala"
	swap_usage = (gdouble) 0;
#line 56 "../src/memory-graph-model.vala"
	_tmp11_ = monitor;
#line 56 "../src/memory-graph-model.vala"
	_tmp12_ = usage_system_monitor_get_ram_total (_tmp11_);
#line 56 "../src/memory-graph-model.vala"
	_tmp13_ = _tmp12_;
#line 56 "../src/memory-graph-model.vala"
	if (_tmp13_ != ((guint64) 0)) {
#line 289 "memory-graph-model.c"
		UsageSystemMonitor* _tmp14_;
		guint64 _tmp15_;
		guint64 _tmp16_;
		UsageSystemMonitor* _tmp17_;
		guint64 _tmp18_;
		guint64 _tmp19_;
#line 57 "../src/memory-graph-model.vala"
		_tmp14_ = monitor;
#line 57 "../src/memory-graph-model.vala"
		_tmp15_ = usage_system_monitor_get_swap_usage (_tmp14_);
#line 57 "../src/memory-graph-model.vala"
		_tmp16_ = _tmp15_;
#line 57 "../src/memory-graph-model.vala"
		_tmp17_ = monitor;
#line 57 "../src/memory-graph-model.vala"
		_tmp18_ = usage_system_monitor_get_swap_total (_tmp17_);
#line 57 "../src/memory-graph-model.vala"
		_tmp19_ = _tmp18_;
#line 57 "../src/memory-graph-model.vala"
		swap_usage = (((gdouble) _tmp16_) / _tmp19_) * 100;
#line 310 "memory-graph-model.c"
	}
#line 59 "../src/memory-graph-model.vala"
	_tmp20_ = iter;
#line 59 "../src/memory-graph-model.vala"
	g_value_init (&_tmp21_, G_TYPE_DOUBLE);
#line 59 "../src/memory-graph-model.vala"
	g_value_set_double (&_tmp21_, ram_usage);
#line 59 "../src/memory-graph-model.vala"
	dzl_graph_view_model_iter_set_value (&_tmp20_, (guint) USAGE_MEMORY_GRAPH_MODEL_COLUMN_RAM, &_tmp21_);
#line 59 "../src/memory-graph-model.vala"
	G_IS_VALUE (&_tmp21_) ? (g_value_unset (&_tmp21_), NULL) : NULL;
#line 60 "../src/memory-graph-model.vala"
	_tmp22_ = iter;
#line 60 "../src/memory-graph-model.vala"
	g_value_init (&_tmp23_, G_TYPE_DOUBLE);
#line 60 "../src/memory-graph-model.vala"
	g_value_set_double (&_tmp23_, swap_usage);
#line 60 "../src/memory-graph-model.vala"
	dzl_graph_view_model_iter_set_value (&_tmp22_, (guint) USAGE_MEMORY_GRAPH_MODEL_COLUMN_SWAP, &_tmp23_);
#line 60 "../src/memory-graph-model.vala"
	G_IS_VALUE (&_tmp23_) ? (g_value_unset (&_tmp23_), NULL) : NULL;
#line 62 "../src/memory-graph-model.vala"
	if (ram_usage >= ((gdouble) 90)) {
#line 63 "../src/memory-graph-model.vala"
		if (self->priv->change_big_ram_usage) {
#line 64 "../src/memory-graph-model.vala"
			g_signal_emit (self, usage_memory_graph_model_signals[USAGE_MEMORY_GRAPH_MODEL_BIG_RAM_USAGE_SIGNAL], 0);
#line 65 "../src/memory-graph-model.vala"
			self->priv->change_big_ram_usage = FALSE;
#line 66 "../src/memory-graph-model.vala"
			self->priv->change_small_ram_usage = TRUE;
#line 342 "memory-graph-model.c"
		}
	} else {
#line 70 "../src/memory-graph-model.vala"
		if (self->priv->change_small_ram_usage) {
#line 71 "../src/memory-graph-model.vala"
			g_signal_emit (self, usage_memory_graph_model_signals[USAGE_MEMORY_GRAPH_MODEL_SMALL_RAM_USAGE_SIGNAL], 0);
#line 72 "../src/memory-graph-model.vala"
			self->priv->change_small_ram_usage = FALSE;
#line 73 "../src/memory-graph-model.vala"
			self->priv->change_big_ram_usage = TRUE;
#line 353 "memory-graph-model.c"
		}
	}
#line 77 "../src/memory-graph-model.vala"
	result = TRUE;
#line 77 "../src/memory-graph-model.vala"
	_g_object_unref0 (monitor);
#line 77 "../src/memory-graph-model.vala"
	return result;
#line 362 "memory-graph-model.c"
}

static void
usage_memory_graph_model_class_init (UsageMemoryGraphModelClass * klass,
                                     gpointer klass_data)
{
#line 25 "../src/memory-graph-model.vala"
	usage_memory_graph_model_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/memory-graph-model.vala"
	g_type_class_adjust_private_offset (klass, &UsageMemoryGraphModel_private_offset);
#line 25 "../src/memory-graph-model.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_memory_graph_model_finalize;
#line 25 "../src/memory-graph-model.vala"
	usage_memory_graph_model_signals[USAGE_MEMORY_GRAPH_MODEL_BIG_RAM_USAGE_SIGNAL] = g_signal_new ("big-ram-usage", USAGE_TYPE_MEMORY_GRAPH_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 25 "../src/memory-graph-model.vala"
	usage_memory_graph_model_signals[USAGE_MEMORY_GRAPH_MODEL_SMALL_RAM_USAGE_SIGNAL] = g_signal_new ("small-ram-usage", USAGE_TYPE_MEMORY_GRAPH_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 379 "memory-graph-model.c"
}

static void
usage_memory_graph_model_instance_init (UsageMemoryGraphModel * self,
                                        gpointer klass)
{
#line 25 "../src/memory-graph-model.vala"
	self->priv = usage_memory_graph_model_get_instance_private (self);
#line 30 "../src/memory-graph-model.vala"
	self->priv->change_big_ram_usage = TRUE;
#line 31 "../src/memory-graph-model.vala"
	self->priv->change_small_ram_usage = TRUE;
#line 392 "memory-graph-model.c"
}

static void
usage_memory_graph_model_finalize (GObject * obj)
{
	UsageMemoryGraphModel * self;
#line 25 "../src/memory-graph-model.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_MEMORY_GRAPH_MODEL, UsageMemoryGraphModel);
#line 25 "../src/memory-graph-model.vala"
	G_OBJECT_CLASS (usage_memory_graph_model_parent_class)->finalize (obj);
#line 403 "memory-graph-model.c"
}

static GType
usage_memory_graph_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageMemoryGraphModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_memory_graph_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageMemoryGraphModel), 0, (GInstanceInitFunc) usage_memory_graph_model_instance_init, NULL };
	GType usage_memory_graph_model_type_id;
	usage_memory_graph_model_type_id = g_type_register_static (dzl_graph_view_model_get_type (), "UsageMemoryGraphModel", &g_define_type_info, 0);
	UsageMemoryGraphModel_private_offset = g_type_add_instance_private (usage_memory_graph_model_type_id, sizeof (UsageMemoryGraphModelPrivate));
	return usage_memory_graph_model_type_id;
}

GType
usage_memory_graph_model_get_type (void)
{
	static volatile gsize usage_memory_graph_model_type_id__once = 0;
	if (g_once_init_enter (&usage_memory_graph_model_type_id__once)) {
		GType usage_memory_graph_model_type_id;
		usage_memory_graph_model_type_id = usage_memory_graph_model_get_type_once ();
		g_once_init_leave (&usage_memory_graph_model_type_id__once, usage_memory_graph_model_type_id);
	}
	return usage_memory_graph_model_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

