/* storage-graph.c generated by valac 0.56.3, the Vala compiler
 * generated from storage-graph.vala, do not modify */

/* storage-graph.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_STORAGE_GRAPH (usage_storage_graph_get_type ())
#define USAGE_STORAGE_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph))
#define USAGE_STORAGE_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraphClass))
#define USAGE_IS_STORAGE_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_GRAPH))
#define USAGE_IS_STORAGE_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_GRAPH))
#define USAGE_STORAGE_GRAPH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraphClass))

typedef struct _UsageStorageGraph UsageStorageGraph;
typedef struct _UsageStorageGraphClass UsageStorageGraphClass;
typedef struct _UsageStorageGraphPrivate UsageStorageGraphPrivate;

#define USAGE_TYPE_STORAGE_VIEW_ITEM (usage_storage_view_item_get_type ())
#define USAGE_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem))
#define USAGE_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))
#define USAGE_IS_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_IS_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_STORAGE_VIEW_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))

typedef struct _UsageStorageViewItem UsageStorageViewItem;
typedef struct _UsageStorageViewItemClass UsageStorageViewItemClass;
enum  {
	USAGE_STORAGE_GRAPH_0_PROPERTY,
	USAGE_STORAGE_GRAPH_MODEL_PROPERTY,
	USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY,
	USAGE_STORAGE_GRAPH_NUM_PROPERTIES
};
static GParamSpec* usage_storage_graph_properties[USAGE_STORAGE_GRAPH_NUM_PROPERTIES];
typedef enum  {
	USAGE_STORAGE_GRAPH_CIRCLE_HOME,
	USAGE_STORAGE_GRAPH_CIRCLE_ROOT,
	USAGE_STORAGE_GRAPH_CIRCLE_BASE
} UsageStorageGraphCircle;

#define USAGE_STORAGE_GRAPH_TYPE_CIRCLE (usage_storage_graph_circle_get_type ())
typedef struct _UsageStorageViewItemPrivate UsageStorageViewItemPrivate;
typedef enum  {
	STORAGE_VIEW_TYPE_NONE,
	STORAGE_VIEW_TYPE_OS,
	STORAGE_VIEW_TYPE_UP_FOLDER,
	STORAGE_VIEW_TYPE_AVAILABLE_GRAPH,
	STORAGE_VIEW_TYPE_ROOT_ITEM
} StorageViewType;

#define TYPE_STORAGE_VIEW_TYPE (storage_view_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UsageStorageGraph {
	GtkDrawingArea parent_instance;
	UsageStorageGraphPrivate * priv;
};

struct _UsageStorageGraphClass {
	GtkDrawingAreaClass parent_class;
};

struct _UsageStorageGraphPrivate {
	GList* selected_items;
	GListStore* _model;
	guint64 selected_size;
	gboolean _root;
	guint _min_percentage_shown_files;
};

struct _UsageStorageViewItem {
	GObject parent_instance;
	UsageStorageViewItemPrivate * priv;
	gchar* uri;
	gchar* name;
	guint64 size;
	GFileType type;
	GUserDirectory* dir;
	gchar* ontology;
	StorageViewType custom_type;
};

struct _UsageStorageViewItemClass {
	GObjectClass parent_class;
};

static gint UsageStorageGraph_private_offset;
static gpointer usage_storage_graph_parent_class = NULL;

VALA_EXTERN GType usage_storage_graph_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageStorageGraph, g_object_unref)
VALA_EXTERN GType usage_storage_view_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageStorageViewItem, g_object_unref)
VALA_EXTERN GType usage_storage_graph_circle_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void usage_storage_graph_update_selected_items (UsageStorageGraph* self,
                                                GList* selected_items);
VALA_EXTERN GType storage_view_type_get_type (void) G_GNUC_CONST ;
static void usage_storage_graph_draw_circle (UsageStorageGraph* self,
                                      cairo_t* context,
                                      gdouble x,
                                      gdouble y,
                                      gdouble radius,
                                      gint section,
                                      UsageStorageGraphCircle circle);
VALA_EXTERN GListStore* usage_storage_graph_get_model (UsageStorageGraph* self);
VALA_EXTERN gdouble usage_storage_view_item_get_percentage (UsageStorageViewItem* self);
VALA_EXTERN guint usage_storage_graph_get_min_percentage_shown_files (UsageStorageGraph* self);
VALA_EXTERN const gchar* usage_storage_view_item_get_style_class (UsageStorageViewItem* self);
static gboolean usage_storage_graph_get_root (UsageStorageGraph* self);
VALA_EXTERN void usage_utils_generate_color (GdkRGBA* default_color,
                                 guint order,
                                 guint all_count,
                                 gboolean reverse,
                                 GdkRGBA* result);
VALA_EXTERN void usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                        GdkRGBA * value);
static gboolean usage_storage_graph_draw_storage_graph (UsageStorageGraph* self,
                                                 cairo_t* context);
static void usage_storage_graph_draw_selected_size_text (UsageStorageGraph* self,
                                                  cairo_t* context);
VALA_EXTERN gchar* usage_utils_format_size_values (guint64 value);
VALA_EXTERN UsageStorageGraph* usage_storage_graph_new (void);
VALA_EXTERN UsageStorageGraph* usage_storage_graph_construct (GType object_type);
static void usage_storage_graph_set_root (UsageStorageGraph* self,
                                   gboolean value);
VALA_EXTERN void usage_storage_graph_set_model (UsageStorageGraph* self,
                                    GListStore* value);
static gboolean _usage_storage_graph_draw_storage_graph_gtk_widget_draw (GtkWidget* _sender,
                                                                  cairo_t* cr,
                                                                  gpointer self);
VALA_EXTERN void usage_storage_graph_set_min_percentage_shown_files (UsageStorageGraph* self,
                                                         guint value);
static void usage_storage_graph_finalize (GObject * obj);
static GType usage_storage_graph_get_type_once (void);
static void _vala_usage_storage_graph_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_usage_storage_graph_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
usage_storage_graph_get_instance_private (UsageStorageGraph* self)
{
	return G_STRUCT_MEMBER_P (self, UsageStorageGraph_private_offset);
}

static GType
usage_storage_graph_circle_get_type_once (void)
{
	static const GEnumValue values[] = {{USAGE_STORAGE_GRAPH_CIRCLE_HOME, "USAGE_STORAGE_GRAPH_CIRCLE_HOME", "home"}, {USAGE_STORAGE_GRAPH_CIRCLE_ROOT, "USAGE_STORAGE_GRAPH_CIRCLE_ROOT", "root"}, {USAGE_STORAGE_GRAPH_CIRCLE_BASE, "USAGE_STORAGE_GRAPH_CIRCLE_BASE", "base"}, {0, NULL, NULL}};
	GType usage_storage_graph_circle_type_id;
	usage_storage_graph_circle_type_id = g_enum_register_static ("UsageStorageGraphCircle", values);
	return usage_storage_graph_circle_type_id;
}

GType
usage_storage_graph_circle_get_type (void)
{
	static volatile gsize usage_storage_graph_circle_type_id__once = 0;
	if (g_once_init_enter (&usage_storage_graph_circle_type_id__once)) {
		GType usage_storage_graph_circle_type_id;
		usage_storage_graph_circle_type_id = usage_storage_graph_circle_get_type_once ();
		g_once_init_leave (&usage_storage_graph_circle_type_id__once, usage_storage_graph_circle_type_id);
	}
	return usage_storage_graph_circle_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 69 "../src/storage/storage-graph.vala"
	return self ? g_object_ref (self) : NULL;
#line 218 "storage-graph.c"
}

void
usage_storage_graph_update_selected_items (UsageStorageGraph* self,
                                           GList* selected_items)
{
	guint64 size = 0ULL;
#line 65 "../src/storage/storage-graph.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/storage/storage-graph.vala"
	self->priv->selected_items = selected_items;
#line 68 "../src/storage/storage-graph.vala"
	size = (guint64) 0;
#line 232 "storage-graph.c"
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
#line 69 "../src/storage/storage-graph.vala"
		item_collection = selected_items;
#line 69 "../src/storage/storage-graph.vala"
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 240 "storage-graph.c"
			UsageStorageViewItem* _tmp0_;
			UsageStorageViewItem* item = NULL;
#line 69 "../src/storage/storage-graph.vala"
			_tmp0_ = _g_object_ref0 ((UsageStorageViewItem*) item_it->data);
#line 69 "../src/storage/storage-graph.vala"
			item = _tmp0_;
#line 247 "storage-graph.c"
			{
				UsageStorageViewItem* _tmp1_;
#line 70 "../src/storage/storage-graph.vala"
				_tmp1_ = item;
#line 70 "../src/storage/storage-graph.vala"
				size += _tmp1_->size;
#line 69 "../src/storage/storage-graph.vala"
				_g_object_unref0 (item);
#line 256 "storage-graph.c"
			}
		}
	}
#line 72 "../src/storage/storage-graph.vala"
	self->priv->selected_size = size;
#line 73 "../src/storage/storage-graph.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 264 "storage-graph.c"
}

static void
usage_storage_graph_draw_circle (UsageStorageGraph* self,
                                 cairo_t* context,
                                 gdouble x,
                                 gdouble y,
                                 gdouble radius,
                                 gint section,
                                 UsageStorageGraphCircle circle)
{
	gdouble start_angle = 0.0;
	gdouble final_angle = 0.0;
	gdouble ratio = 0.0;
	guint shown_items_number = 0U;
	GdkRGBA background_color = {0};
	GtkWidget* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkWidget* _tmp2_;
	GtkStyleContext* _tmp3_;
	GdkRGBA _tmp4_ = {0};
	GdkRGBA foreground_color = {0};
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
	GdkRGBA _tmp7_ = {0};
#line 76 "../src/storage/storage-graph.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/storage/storage-graph.vala"
	g_return_if_fail (context != NULL);
#line 78 "../src/storage/storage-graph.vala"
	start_angle = (gdouble) 0;
#line 79 "../src/storage/storage-graph.vala"
	final_angle = (-G_PI) / 2.0;
#line 80 "../src/storage/storage-graph.vala"
	ratio = (gdouble) 0;
#line 81 "../src/storage/storage-graph.vala"
	shown_items_number = (guint) 1;
#line 82 "../src/storage/storage-graph.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 82 "../src/storage/storage-graph.vala"
	_tmp1_ = gtk_widget_get_style_context (_tmp0_);
#line 82 "../src/storage/storage-graph.vala"
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 82 "../src/storage/storage-graph.vala"
	_tmp3_ = gtk_widget_get_style_context (_tmp2_);
#line 82 "../src/storage/storage-graph.vala"
	gtk_style_context_get_background_color (_tmp1_, gtk_style_context_get_state (_tmp3_), &_tmp4_);
#line 82 "../src/storage/storage-graph.vala"
	background_color = _tmp4_;
#line 83 "../src/storage/storage-graph.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 83 "../src/storage/storage-graph.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 83 "../src/storage/storage-graph.vala"
	gtk_style_context_get_color (_tmp5_, gtk_style_context_get_state (_tmp6_), &_tmp7_);
#line 83 "../src/storage/storage-graph.vala"
	foreground_color = _tmp7_;
#line 322 "storage-graph.c"
	{
		gint i = 0;
#line 85 "../src/storage/storage-graph.vala"
		i = 1;
#line 327 "storage-graph.c"
		{
			gboolean _tmp8_ = FALSE;
#line 85 "../src/storage/storage-graph.vala"
			_tmp8_ = TRUE;
#line 85 "../src/storage/storage-graph.vala"
			while (TRUE) {
#line 334 "storage-graph.c"
				GListStore* _tmp10_;
				GListStore* _tmp11_;
				UsageStorageViewItem* item = NULL;
				GListStore* _tmp12_;
				GListStore* _tmp13_;
				GObject* _tmp14_;
				UsageStorageViewItem* _tmp15_;
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
				UsageStorageViewItem* _tmp24_;
				gdouble _tmp25_;
				gdouble _tmp26_;
				guint _tmp27_;
#line 85 "../src/storage/storage-graph.vala"
				if (!_tmp8_) {
#line 350 "storage-graph.c"
					gint _tmp9_;
#line 85 "../src/storage/storage-graph.vala"
					_tmp9_ = i;
#line 85 "../src/storage/storage-graph.vala"
					i = _tmp9_ + 1;
#line 356 "storage-graph.c"
				}
#line 85 "../src/storage/storage-graph.vala"
				_tmp8_ = FALSE;
#line 85 "../src/storage/storage-graph.vala"
				_tmp10_ = usage_storage_graph_get_model (self);
#line 85 "../src/storage/storage-graph.vala"
				_tmp11_ = _tmp10_;
#line 85 "../src/storage/storage-graph.vala"
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp11_))) {
#line 85 "../src/storage/storage-graph.vala"
					break;
#line 368 "storage-graph.c"
				}
#line 86 "../src/storage/storage-graph.vala"
				_tmp12_ = usage_storage_graph_get_model (self);
#line 86 "../src/storage/storage-graph.vala"
				_tmp13_ = _tmp12_;
#line 86 "../src/storage/storage-graph.vala"
				_tmp14_ = g_list_model_get_item ((GListModel*) _tmp13_, (guint) i);
#line 86 "../src/storage/storage-graph.vala"
				_tmp15_ = USAGE_IS_STORAGE_VIEW_ITEM (_tmp14_) ? ((UsageStorageViewItem*) _tmp14_) : NULL;
#line 86 "../src/storage/storage-graph.vala"
				if (_tmp15_ == NULL) {
#line 86 "../src/storage/storage-graph.vala"
					_g_object_unref0 (_tmp14_);
#line 382 "storage-graph.c"
				}
#line 86 "../src/storage/storage-graph.vala"
				item = _tmp15_;
#line 88 "../src/storage/storage-graph.vala"
				if (i > 0) {
#line 88 "../src/storage/storage-graph.vala"
					_tmp17_ = i < 3;
#line 390 "storage-graph.c"
				} else {
#line 88 "../src/storage/storage-graph.vala"
					_tmp17_ = FALSE;
#line 394 "storage-graph.c"
				}
#line 88 "../src/storage/storage-graph.vala"
				if (_tmp17_) {
#line 398 "storage-graph.c"
					UsageStorageViewItem* _tmp18_;
					gdouble _tmp19_;
					gdouble _tmp20_;
					guint _tmp21_;
#line 88 "../src/storage/storage-graph.vala"
					_tmp18_ = item;
#line 88 "../src/storage/storage-graph.vala"
					_tmp19_ = usage_storage_view_item_get_percentage (_tmp18_);
#line 88 "../src/storage/storage-graph.vala"
					_tmp20_ = _tmp19_;
#line 88 "../src/storage/storage-graph.vala"
					_tmp21_ = self->priv->_min_percentage_shown_files;
#line 88 "../src/storage/storage-graph.vala"
					_tmp16_ = _tmp20_ < ((gdouble) _tmp21_);
#line 413 "storage-graph.c"
				} else {
#line 88 "../src/storage/storage-graph.vala"
					_tmp16_ = FALSE;
#line 417 "storage-graph.c"
				}
#line 88 "../src/storage/storage-graph.vala"
				if (_tmp16_) {
#line 421 "storage-graph.c"
					GListStore* _tmp22_;
					GListStore* _tmp23_;
#line 89 "../src/storage/storage-graph.vala"
					_tmp22_ = usage_storage_graph_get_model (self);
#line 89 "../src/storage/storage-graph.vala"
					_tmp23_ = _tmp22_;
#line 89 "../src/storage/storage-graph.vala"
					shown_items_number = g_list_model_get_n_items ((GListModel*) _tmp23_);
#line 90 "../src/storage/storage-graph.vala"
					_g_object_unref0 (item);
#line 90 "../src/storage/storage-graph.vala"
					continue;
#line 434 "storage-graph.c"
				}
#line 93 "../src/storage/storage-graph.vala"
				_tmp24_ = item;
#line 93 "../src/storage/storage-graph.vala"
				_tmp25_ = usage_storage_view_item_get_percentage (_tmp24_);
#line 93 "../src/storage/storage-graph.vala"
				_tmp26_ = _tmp25_;
#line 93 "../src/storage/storage-graph.vala"
				_tmp27_ = self->priv->_min_percentage_shown_files;
#line 93 "../src/storage/storage-graph.vala"
				if (_tmp26_ > ((gdouble) _tmp27_)) {
#line 94 "../src/storage/storage-graph.vala"
					shown_items_number = shown_items_number + 1;
#line 448 "storage-graph.c"
				}
#line 85 "../src/storage/storage-graph.vala"
				_g_object_unref0 (item);
#line 452 "storage-graph.c"
			}
		}
	}
#line 97 "../src/storage/storage-graph.vala"
	if (shown_items_number > ((guint) 1)) {
#line 458 "storage-graph.c"
		GdkRGBA _tmp69_;
		GdkRGBA _tmp70_;
#line 98 "../src/storage/storage-graph.vala"
		if (shown_items_number < ((guint) 3)) {
#line 99 "../src/storage/storage-graph.vala"
			shown_items_number = (guint) 3;
#line 465 "storage-graph.c"
		}
		{
			gint i = 0;
#line 101 "../src/storage/storage-graph.vala"
			i = 0;
#line 471 "storage-graph.c"
			{
				gboolean _tmp28_ = FALSE;
#line 101 "../src/storage/storage-graph.vala"
				_tmp28_ = TRUE;
#line 101 "../src/storage/storage-graph.vala"
				while (TRUE) {
#line 478 "storage-graph.c"
					GListStore* _tmp30_;
					GListStore* _tmp31_;
					UsageStorageViewItem* item = NULL;
					GListStore* _tmp32_;
					GListStore* _tmp33_;
					GObject* _tmp34_;
					UsageStorageViewItem* _tmp35_;
					gdouble item_radius = 0.0;
					gboolean _tmp36_ = FALSE;
					UsageStorageViewItem* _tmp37_;
					GtkStyleContext* style_context = NULL;
					GtkStyleContext* _tmp39_;
					GtkStyleContext* _tmp40_;
					GtkStyleContext* _tmp41_;
					UsageStorageViewItem* _tmp42_;
					const gchar* _tmp43_;
					const gchar* _tmp44_;
					GdkRGBA base_color = {0};
					GtkStyleContext* _tmp45_;
					GtkStyleContext* _tmp46_;
					GdkRGBA _tmp47_ = {0};
					GtkStyleContext* _tmp48_;
					UsageStorageViewItem* _tmp49_;
					const gchar* _tmp50_;
					const gchar* _tmp51_;
					GdkRGBA fill_color = {0};
					GdkRGBA _tmp52_;
					gboolean _tmp53_;
					GList* _tmp58_;
					UsageStorageViewItem* _tmp59_;
					GList* _tmp60_;
					UsageStorageViewItem* _tmp61_;
					gdouble _tmp62_;
					gdouble _tmp63_;
					GdkRGBA _tmp67_;
					GdkRGBA _tmp68_;
#line 101 "../src/storage/storage-graph.vala"
					if (!_tmp28_) {
#line 517 "storage-graph.c"
						gint _tmp29_;
#line 101 "../src/storage/storage-graph.vala"
						_tmp29_ = i;
#line 101 "../src/storage/storage-graph.vala"
						i = _tmp29_ + 1;
#line 523 "storage-graph.c"
					}
#line 101 "../src/storage/storage-graph.vala"
					_tmp28_ = FALSE;
#line 101 "../src/storage/storage-graph.vala"
					_tmp30_ = usage_storage_graph_get_model (self);
#line 101 "../src/storage/storage-graph.vala"
					_tmp31_ = _tmp30_;
#line 101 "../src/storage/storage-graph.vala"
					if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp31_))) {
#line 101 "../src/storage/storage-graph.vala"
						break;
#line 535 "storage-graph.c"
					}
#line 103 "../src/storage/storage-graph.vala"
					_tmp32_ = usage_storage_graph_get_model (self);
#line 103 "../src/storage/storage-graph.vala"
					_tmp33_ = _tmp32_;
#line 103 "../src/storage/storage-graph.vala"
					_tmp34_ = g_list_model_get_item ((GListModel*) _tmp33_, (guint) i);
#line 103 "../src/storage/storage-graph.vala"
					_tmp35_ = USAGE_IS_STORAGE_VIEW_ITEM (_tmp34_) ? ((UsageStorageViewItem*) _tmp34_) : NULL;
#line 103 "../src/storage/storage-graph.vala"
					if (_tmp35_ == NULL) {
#line 103 "../src/storage/storage-graph.vala"
						_g_object_unref0 (_tmp34_);
#line 549 "storage-graph.c"
					}
#line 103 "../src/storage/storage-graph.vala"
					item = _tmp35_;
#line 104 "../src/storage/storage-graph.vala"
					item_radius = radius;
#line 105 "../src/storage/storage-graph.vala"
					_tmp37_ = item;
#line 105 "../src/storage/storage-graph.vala"
					if (_tmp37_->custom_type == STORAGE_VIEW_TYPE_UP_FOLDER) {
#line 105 "../src/storage/storage-graph.vala"
						_tmp36_ = TRUE;
#line 561 "storage-graph.c"
					} else {
						UsageStorageViewItem* _tmp38_;
#line 105 "../src/storage/storage-graph.vala"
						_tmp38_ = item;
#line 105 "../src/storage/storage-graph.vala"
						_tmp36_ = _tmp38_->size == ((guint64) 0);
#line 568 "storage-graph.c"
					}
#line 105 "../src/storage/storage-graph.vala"
					if (_tmp36_) {
#line 106 "../src/storage/storage-graph.vala"
						_g_object_unref0 (item);
#line 106 "../src/storage/storage-graph.vala"
						continue;
#line 576 "storage-graph.c"
					}
#line 108 "../src/storage/storage-graph.vala"
					_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 108 "../src/storage/storage-graph.vala"
					_tmp40_ = _g_object_ref0 (_tmp39_);
#line 108 "../src/storage/storage-graph.vala"
					style_context = _tmp40_;
#line 109 "../src/storage/storage-graph.vala"
					_tmp41_ = style_context;
#line 109 "../src/storage/storage-graph.vala"
					_tmp42_ = item;
#line 109 "../src/storage/storage-graph.vala"
					_tmp43_ = usage_storage_view_item_get_style_class (_tmp42_);
#line 109 "../src/storage/storage-graph.vala"
					_tmp44_ = _tmp43_;
#line 109 "../src/storage/storage-graph.vala"
					gtk_style_context_add_class (_tmp41_, _tmp44_);
#line 110 "../src/storage/storage-graph.vala"
					_tmp45_ = style_context;
#line 110 "../src/storage/storage-graph.vala"
					_tmp46_ = style_context;
#line 110 "../src/storage/storage-graph.vala"
					gtk_style_context_get_background_color (_tmp45_, gtk_style_context_get_state (_tmp46_), &_tmp47_);
#line 110 "../src/storage/storage-graph.vala"
					base_color = _tmp47_;
#line 111 "../src/storage/storage-graph.vala"
					_tmp48_ = style_context;
#line 111 "../src/storage/storage-graph.vala"
					_tmp49_ = item;
#line 111 "../src/storage/storage-graph.vala"
					_tmp50_ = usage_storage_view_item_get_style_class (_tmp49_);
#line 111 "../src/storage/storage-graph.vala"
					_tmp51_ = _tmp50_;
#line 111 "../src/storage/storage-graph.vala"
					gtk_style_context_remove_class (_tmp48_, _tmp51_);
#line 113 "../src/storage/storage-graph.vala"
					_tmp52_ = base_color;
#line 113 "../src/storage/storage-graph.vala"
					fill_color = _tmp52_;
#line 115 "../src/storage/storage-graph.vala"
					_tmp53_ = self->priv->_root;
#line 115 "../src/storage/storage-graph.vala"
					if (!_tmp53_) {
#line 620 "storage-graph.c"
						GdkRGBA _tmp54_;
						GdkRGBA _tmp55_ = {0};
						UsageStorageViewItem* _tmp56_;
						GdkRGBA _tmp57_;
#line 116 "../src/storage/storage-graph.vala"
						_tmp54_ = base_color;
#line 116 "../src/storage/storage-graph.vala"
						usage_utils_generate_color (&_tmp54_, (guint) i, shown_items_number, TRUE, &_tmp55_);
#line 116 "../src/storage/storage-graph.vala"
						fill_color = _tmp55_;
#line 117 "../src/storage/storage-graph.vala"
						_tmp56_ = item;
#line 117 "../src/storage/storage-graph.vala"
						_tmp57_ = fill_color;
#line 117 "../src/storage/storage-graph.vala"
						usage_storage_view_item_set_color (_tmp56_, &_tmp57_);
#line 637 "storage-graph.c"
					}
#line 120 "../src/storage/storage-graph.vala"
					_tmp58_ = self->priv->selected_items;
#line 120 "../src/storage/storage-graph.vala"
					_tmp59_ = item;
#line 120 "../src/storage/storage-graph.vala"
					_tmp60_ = g_list_find (_tmp58_, _tmp59_);
#line 120 "../src/storage/storage-graph.vala"
					if (_tmp60_ != NULL) {
#line 121 "../src/storage/storage-graph.vala"
						item_radius += radius / 6;
#line 649 "storage-graph.c"
					}
#line 123 "../src/storage/storage-graph.vala"
					cairo_set_line_width (context, 2.0);
#line 124 "../src/storage/storage-graph.vala"
					start_angle = final_angle;
#line 126 "../src/storage/storage-graph.vala"
					_tmp61_ = item;
#line 126 "../src/storage/storage-graph.vala"
					_tmp62_ = usage_storage_view_item_get_percentage (_tmp61_);
#line 126 "../src/storage/storage-graph.vala"
					_tmp63_ = _tmp62_;
#line 126 "../src/storage/storage-graph.vala"
					if (_tmp63_ < 0.3) {
#line 127 "../src/storage/storage-graph.vala"
						ratio = ratio + (((gdouble) 0.3) / 100);
#line 665 "storage-graph.c"
					} else {
						UsageStorageViewItem* _tmp64_;
						gdouble _tmp65_;
						gdouble _tmp66_;
#line 129 "../src/storage/storage-graph.vala"
						_tmp64_ = item;
#line 129 "../src/storage/storage-graph.vala"
						_tmp65_ = usage_storage_view_item_get_percentage (_tmp64_);
#line 129 "../src/storage/storage-graph.vala"
						_tmp66_ = _tmp65_;
#line 129 "../src/storage/storage-graph.vala"
						ratio = ratio + (((gdouble) _tmp66_) / 100);
#line 678 "storage-graph.c"
					}
#line 131 "../src/storage/storage-graph.vala"
					final_angle = ((ratio * 2) * G_PI) - (G_PI / 2.0);
#line 132 "../src/storage/storage-graph.vala"
					if (final_angle >= ((2 * G_PI) - (G_PI / 2.0))) {
#line 133 "../src/storage/storage-graph.vala"
						final_angle = (2 * G_PI) - (G_PI / 2.0);
#line 686 "storage-graph.c"
					}
#line 135 "../src/storage/storage-graph.vala"
					cairo_move_to (context, x, y);
#line 136 "../src/storage/storage-graph.vala"
					_tmp67_ = fill_color;
#line 136 "../src/storage/storage-graph.vala"
					gdk_cairo_set_source_rgba (context, &_tmp67_);
#line 137 "../src/storage/storage-graph.vala"
					cairo_arc (context, x, y, item_radius, start_angle, final_angle);
#line 138 "../src/storage/storage-graph.vala"
					cairo_line_to (context, x, y);
#line 139 "../src/storage/storage-graph.vala"
					cairo_fill_preserve (context);
#line 140 "../src/storage/storage-graph.vala"
					_tmp68_ = foreground_color;
#line 140 "../src/storage/storage-graph.vala"
					gdk_cairo_set_source_rgba (context, &_tmp68_);
#line 141 "../src/storage/storage-graph.vala"
					cairo_stroke (context);
#line 143 "../src/storage/storage-graph.vala"
					if (start_angle >= ((2 * G_PI) - (G_PI / 2.0))) {
#line 144 "../src/storage/storage-graph.vala"
						_g_object_unref0 (style_context);
#line 144 "../src/storage/storage-graph.vala"
						_g_object_unref0 (item);
#line 144 "../src/storage/storage-graph.vala"
						break;
#line 714 "storage-graph.c"
					}
#line 101 "../src/storage/storage-graph.vala"
					_g_object_unref0 (style_context);
#line 101 "../src/storage/storage-graph.vala"
					_g_object_unref0 (item);
#line 720 "storage-graph.c"
				}
			}
		}
#line 147 "../src/storage/storage-graph.vala"
		cairo_move_to (context, x, y);
#line 148 "../src/storage/storage-graph.vala"
		cairo_line_to (context, x, y - radius);
#line 149 "../src/storage/storage-graph.vala"
		cairo_stroke (context);
#line 151 "../src/storage/storage-graph.vala"
		cairo_arc (context, x, y, radius / 1.8, (gdouble) 0, 2 * G_PI);
#line 152 "../src/storage/storage-graph.vala"
		_tmp69_ = background_color;
#line 152 "../src/storage/storage-graph.vala"
		gdk_cairo_set_source_rgba (context, &_tmp69_);
#line 153 "../src/storage/storage-graph.vala"
		cairo_fill_preserve (context);
#line 154 "../src/storage/storage-graph.vala"
		_tmp70_ = foreground_color;
#line 154 "../src/storage/storage-graph.vala"
		gdk_cairo_set_source_rgba (context, &_tmp70_);
#line 155 "../src/storage/storage-graph.vala"
		cairo_stroke (context);
#line 744 "storage-graph.c"
	}
}

static gboolean
usage_storage_graph_draw_storage_graph (UsageStorageGraph* self,
                                        cairo_t* context)
{
	gint height = 0;
	gint width = 0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble radius = 0.0;
	gboolean result;
#line 159 "../src/storage/storage-graph.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../src/storage/storage-graph.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 161 "../src/storage/storage-graph.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 162 "../src/storage/storage-graph.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 164 "../src/storage/storage-graph.vala"
	x = (gdouble) 0;
#line 165 "../src/storage/storage-graph.vala"
	y = (gdouble) 0;
#line 166 "../src/storage/storage-graph.vala"
	radius = (gdouble) 0;
#line 168 "../src/storage/storage-graph.vala"
	radius = MIN (width, height) / 2.0;
#line 169 "../src/storage/storage-graph.vala"
	radius -= radius / 4;
#line 170 "../src/storage/storage-graph.vala"
	x = width / 2.0;
#line 171 "../src/storage/storage-graph.vala"
	y = height / 2.0;
#line 173 "../src/storage/storage-graph.vala"
	usage_storage_graph_draw_circle (self, context, x, y, radius, 0, USAGE_STORAGE_GRAPH_CIRCLE_BASE);
#line 174 "../src/storage/storage-graph.vala"
	usage_storage_graph_draw_selected_size_text (self, context);
#line 176 "../src/storage/storage-graph.vala"
	result = TRUE;
#line 176 "../src/storage/storage-graph.vala"
	return result;
#line 788 "storage-graph.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 819 "storage-graph.c"
}

static void
usage_storage_graph_draw_selected_size_text (UsageStorageGraph* self,
                                             cairo_t* context)
{
	PangoLayout* layout = NULL;
	PangoLayout* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
	gint height = 0;
	gint width = 0;
	gdouble radius = 0.0;
	GdkRGBA text_color = {0};
	GtkWidget* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkWidget* _tmp4_;
	GtkStyleContext* _tmp5_;
	GdkRGBA _tmp6_ = {0};
	gchar* text_color_string = NULL;
	GdkRGBA _tmp7_;
	GdkRGBA _tmp8_;
	GdkRGBA _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* markup = NULL;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	PangoLayout* _tmp30_;
	const gchar* _tmp31_;
	PangoRectangle layout_rect = {0};
	PangoLayout* _tmp32_;
	PangoRectangle _tmp33_ = {0};
	PangoLayout* _tmp34_;
	gint x = 0;
	PangoRectangle _tmp35_;
	gint y = 0;
	PangoRectangle _tmp36_;
	GtkStyleContext* _tmp37_;
	PangoLayout* _tmp38_;
#line 179 "../src/storage/storage-graph.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/storage/storage-graph.vala"
	g_return_if_fail (context != NULL);
#line 181 "../src/storage/storage-graph.vala"
	if (self->priv->selected_size == ((guint64) 0)) {
#line 182 "../src/storage/storage-graph.vala"
		return;
#line 884 "storage-graph.c"
	}
#line 184 "../src/storage/storage-graph.vala"
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) self, NULL);
#line 184 "../src/storage/storage-graph.vala"
	layout = _tmp0_;
#line 185 "../src/storage/storage-graph.vala"
	_tmp1_ = usage_utils_format_size_values (self->priv->selected_size);
#line 185 "../src/storage/storage-graph.vala"
	text = _tmp1_;
#line 187 "../src/storage/storage-graph.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 188 "../src/storage/storage-graph.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 189 "../src/storage/storage-graph.vala"
	radius = (gdouble) (MIN (width, height) / 22);
#line 191 "../src/storage/storage-graph.vala"
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 191 "../src/storage/storage-graph.vala"
	_tmp3_ = gtk_widget_get_style_context (_tmp2_);
#line 191 "../src/storage/storage-graph.vala"
	_tmp4_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 191 "../src/storage/storage-graph.vala"
	_tmp5_ = gtk_widget_get_style_context (_tmp4_);
#line 191 "../src/storage/storage-graph.vala"
	gtk_style_context_get_color (_tmp3_, gtk_style_context_get_state (_tmp5_), &_tmp6_);
#line 191 "../src/storage/storage-graph.vala"
	text_color = _tmp6_;
#line 192 "../src/storage/storage-graph.vala"
	_tmp7_ = text_color;
#line 192 "../src/storage/storage-graph.vala"
	_tmp8_ = text_color;
#line 192 "../src/storage/storage-graph.vala"
	_tmp9_ = text_color;
#line 192 "../src/storage/storage-graph.vala"
	_tmp10_ = g_strdup_printf ("#%02x%02x%02x", (guint) round (_tmp7_.red * 255), (guint) round (_tmp8_.green * 255), (guint) round (_tmp9_.blue * 255));
#line 192 "../src/storage/storage-graph.vala"
	_tmp11_ = _tmp10_;
#line 192 "../src/storage/storage-graph.vala"
	_tmp12_ = g_utf8_strup (_tmp11_, (gssize) -1);
#line 192 "../src/storage/storage-graph.vala"
	_tmp13_ = _tmp12_;
#line 192 "../src/storage/storage-graph.vala"
	_g_free0 (_tmp11_);
#line 192 "../src/storage/storage-graph.vala"
	text_color_string = _tmp13_;
#line 197 "../src/storage/storage-graph.vala"
	_tmp14_ = text_color_string;
#line 197 "../src/storage/storage-graph.vala"
	_tmp15_ = g_strconcat ("<span foreground='", _tmp14_, NULL);
#line 197 "../src/storage/storage-graph.vala"
	_tmp16_ = _tmp15_;
#line 197 "../src/storage/storage-graph.vala"
	_tmp17_ = g_strconcat (_tmp16_, "' font='", NULL);
#line 197 "../src/storage/storage-graph.vala"
	_tmp18_ = _tmp17_;
#line 197 "../src/storage/storage-graph.vala"
	_tmp19_ = double_to_string (radius);
#line 197 "../src/storage/storage-graph.vala"
	_tmp20_ = _tmp19_;
#line 197 "../src/storage/storage-graph.vala"
	_tmp21_ = g_strconcat (_tmp18_, _tmp20_, NULL);
#line 197 "../src/storage/storage-graph.vala"
	_tmp22_ = _tmp21_;
#line 197 "../src/storage/storage-graph.vala"
	_tmp23_ = g_strconcat (_tmp22_, "'><b>", NULL);
#line 197 "../src/storage/storage-graph.vala"
	_tmp24_ = _tmp23_;
#line 197 "../src/storage/storage-graph.vala"
	_tmp25_ = text;
#line 197 "../src/storage/storage-graph.vala"
	_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 197 "../src/storage/storage-graph.vala"
	_tmp27_ = _tmp26_;
#line 197 "../src/storage/storage-graph.vala"
	_tmp28_ = g_strconcat (_tmp27_, "</b></span>", NULL);
#line 197 "../src/storage/storage-graph.vala"
	_tmp29_ = _tmp28_;
#line 197 "../src/storage/storage-graph.vala"
	_g_free0 (_tmp27_);
#line 197 "../src/storage/storage-graph.vala"
	_g_free0 (_tmp24_);
#line 197 "../src/storage/storage-graph.vala"
	_g_free0 (_tmp22_);
#line 197 "../src/storage/storage-graph.vala"
	_g_free0 (_tmp20_);
#line 197 "../src/storage/storage-graph.vala"
	_g_free0 (_tmp18_);
#line 197 "../src/storage/storage-graph.vala"
	_g_free0 (_tmp16_);
#line 197 "../src/storage/storage-graph.vala"
	markup = _tmp29_;
#line 198 "../src/storage/storage-graph.vala"
	_tmp30_ = layout;
#line 198 "../src/storage/storage-graph.vala"
	_tmp31_ = markup;
#line 198 "../src/storage/storage-graph.vala"
	pango_layout_set_markup (_tmp30_, _tmp31_, -1);
#line 201 "../src/storage/storage-graph.vala"
	_tmp32_ = layout;
#line 201 "../src/storage/storage-graph.vala"
	pango_layout_get_pixel_extents (_tmp32_, NULL, &_tmp33_);
#line 201 "../src/storage/storage-graph.vala"
	layout_rect = _tmp33_;
#line 202 "../src/storage/storage-graph.vala"
	_tmp34_ = layout;
#line 202 "../src/storage/storage-graph.vala"
	pango_layout_set_alignment (_tmp34_, PANGO_ALIGN_CENTER);
#line 204 "../src/storage/storage-graph.vala"
	_tmp35_ = layout_rect;
#line 204 "../src/storage/storage-graph.vala"
	x = (width - _tmp35_.width) / 2;
#line 205 "../src/storage/storage-graph.vala"
	_tmp36_ = layout_rect;
#line 205 "../src/storage/storage-graph.vala"
	y = (height - _tmp36_.height) / 2;
#line 206 "../src/storage/storage-graph.vala"
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 206 "../src/storage/storage-graph.vala"
	_tmp38_ = layout;
#line 206 "../src/storage/storage-graph.vala"
	gtk_render_layout (_tmp37_, context, (gdouble) x, (gdouble) y, _tmp38_);
#line 179 "../src/storage/storage-graph.vala"
	_g_free0 (markup);
#line 179 "../src/storage/storage-graph.vala"
	_g_free0 (text_color_string);
#line 179 "../src/storage/storage-graph.vala"
	_g_free0 (text);
#line 179 "../src/storage/storage-graph.vala"
	_g_object_unref0 (layout);
#line 1014 "storage-graph.c"
}

UsageStorageGraph*
usage_storage_graph_construct (GType object_type)
{
	UsageStorageGraph * self = NULL;
#line 25 "../src/storage/storage-graph.vala"
	self = (UsageStorageGraph*) g_object_new (object_type, NULL);
#line 25 "../src/storage/storage-graph.vala"
	return self;
#line 1025 "storage-graph.c"
}

UsageStorageGraph*
usage_storage_graph_new (void)
{
#line 25 "../src/storage/storage-graph.vala"
	return usage_storage_graph_construct (USAGE_TYPE_STORAGE_GRAPH);
#line 1033 "storage-graph.c"
}

static gboolean
usage_storage_graph_get_root (UsageStorageGraph* self)
{
	gboolean result;
#line 30 "../src/storage/storage-graph.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/storage/storage-graph.vala"
	result = self->priv->_root;
#line 30 "../src/storage/storage-graph.vala"
	return result;
#line 1046 "storage-graph.c"
}

static void
usage_storage_graph_set_root (UsageStorageGraph* self,
                              gboolean value)
{
#line 30 "../src/storage/storage-graph.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/storage/storage-graph.vala"
	self->priv->_root = value;
#line 1057 "storage-graph.c"
}

GListStore*
usage_storage_graph_get_model (UsageStorageGraph* self)
{
	GListStore* result;
	GListStore* _tmp0_;
#line 48 "../src/storage/storage-graph.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/storage/storage-graph.vala"
	_tmp0_ = self->priv->_model;
#line 48 "../src/storage/storage-graph.vala"
	result = _tmp0_;
#line 48 "../src/storage/storage-graph.vala"
	return result;
#line 1073 "storage-graph.c"
}

static gboolean
_usage_storage_graph_draw_storage_graph_gtk_widget_draw (GtkWidget* _sender,
                                                         cairo_t* cr,
                                                         gpointer self)
{
	gboolean result;
	result = usage_storage_graph_draw_storage_graph ((UsageStorageGraph*) self, cr);
#line 35 "../src/storage/storage-graph.vala"
	return result;
#line 1085 "storage-graph.c"
}

void
usage_storage_graph_set_model (UsageStorageGraph* self,
                               GListStore* value)
{
#line 33 "../src/storage/storage-graph.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/storage/storage-graph.vala"
	self->priv->_model = value;
#line 35 "../src/storage/storage-graph.vala"
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _usage_storage_graph_draw_storage_graph_gtk_widget_draw, self, 0);
#line 36 "../src/storage/storage-graph.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 37 "../src/storage/storage-graph.vala"
	usage_storage_graph_set_root (self, FALSE);
#line 1102 "storage-graph.c"
	{
		gint i = 0;
#line 39 "../src/storage/storage-graph.vala"
		i = 0;
#line 1107 "storage-graph.c"
		{
			gboolean _tmp0_ = FALSE;
#line 39 "../src/storage/storage-graph.vala"
			_tmp0_ = TRUE;
#line 39 "../src/storage/storage-graph.vala"
			while (TRUE) {
#line 1114 "storage-graph.c"
				UsageStorageViewItem* item = NULL;
				GListStore* _tmp2_;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				UsageStorageViewItem* _tmp5_;
				UsageStorageViewItem* _tmp6_;
#line 39 "../src/storage/storage-graph.vala"
				if (!_tmp0_) {
#line 1123 "storage-graph.c"
					gint _tmp1_;
#line 39 "../src/storage/storage-graph.vala"
					_tmp1_ = i;
#line 39 "../src/storage/storage-graph.vala"
					i = _tmp1_ + 1;
#line 1129 "storage-graph.c"
				}
#line 39 "../src/storage/storage-graph.vala"
				_tmp0_ = FALSE;
#line 39 "../src/storage/storage-graph.vala"
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) value))) {
#line 39 "../src/storage/storage-graph.vala"
					break;
#line 1137 "storage-graph.c"
				}
#line 41 "../src/storage/storage-graph.vala"
				_tmp2_ = usage_storage_graph_get_model (self);
#line 41 "../src/storage/storage-graph.vala"
				_tmp3_ = _tmp2_;
#line 41 "../src/storage/storage-graph.vala"
				_tmp4_ = g_list_model_get_item ((GListModel*) _tmp3_, (guint) i);
#line 41 "../src/storage/storage-graph.vala"
				_tmp5_ = USAGE_IS_STORAGE_VIEW_ITEM (_tmp4_) ? ((UsageStorageViewItem*) _tmp4_) : NULL;
#line 41 "../src/storage/storage-graph.vala"
				if (_tmp5_ == NULL) {
#line 41 "../src/storage/storage-graph.vala"
					_g_object_unref0 (_tmp4_);
#line 1151 "storage-graph.c"
				}
#line 41 "../src/storage/storage-graph.vala"
				item = _tmp5_;
#line 42 "../src/storage/storage-graph.vala"
				_tmp6_ = item;
#line 42 "../src/storage/storage-graph.vala"
				if (_tmp6_->custom_type == STORAGE_VIEW_TYPE_OS) {
#line 43 "../src/storage/storage-graph.vala"
					usage_storage_graph_set_root (self, TRUE);
#line 44 "../src/storage/storage-graph.vala"
					_g_object_unref0 (item);
#line 44 "../src/storage/storage-graph.vala"
					break;
#line 1165 "storage-graph.c"
				}
#line 39 "../src/storage/storage-graph.vala"
				_g_object_unref0 (item);
#line 1169 "storage-graph.c"
			}
		}
	}
#line 33 "../src/storage/storage-graph.vala"
	g_object_notify_by_pspec ((GObject *) self, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MODEL_PROPERTY]);
#line 1175 "storage-graph.c"
}

guint
usage_storage_graph_get_min_percentage_shown_files (UsageStorageGraph* self)
{
	guint result;
#line 51 "../src/storage/storage-graph.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 51 "../src/storage/storage-graph.vala"
	result = self->priv->_min_percentage_shown_files;
#line 51 "../src/storage/storage-graph.vala"
	return result;
#line 1188 "storage-graph.c"
}

void
usage_storage_graph_set_min_percentage_shown_files (UsageStorageGraph* self,
                                                    guint value)
{
	guint old_value;
#line 51 "../src/storage/storage-graph.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/storage/storage-graph.vala"
	old_value = usage_storage_graph_get_min_percentage_shown_files (self);
#line 51 "../src/storage/storage-graph.vala"
	if (old_value != value) {
#line 51 "../src/storage/storage-graph.vala"
		self->priv->_min_percentage_shown_files = value;
#line 51 "../src/storage/storage-graph.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY]);
#line 1206 "storage-graph.c"
	}
}

static void
usage_storage_graph_base_init (UsageStorageGraphClass * klass)
{
#line 55 "../src/storage/storage-graph.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "StorageGraph");
#line 1215 "storage-graph.c"
}

static void
usage_storage_graph_class_init (UsageStorageGraphClass * klass,
                                gpointer klass_data)
{
#line 25 "../src/storage/storage-graph.vala"
	usage_storage_graph_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/storage/storage-graph.vala"
	g_type_class_adjust_private_offset (klass, &UsageStorageGraph_private_offset);
#line 25 "../src/storage/storage-graph.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_storage_graph_get_property;
#line 25 "../src/storage/storage-graph.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_storage_graph_set_property;
#line 25 "../src/storage/storage-graph.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_storage_graph_finalize;
#line 25 "../src/storage/storage-graph.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_GRAPH_MODEL_PROPERTY, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MODEL_PROPERTY] = g_param_spec_object ("model", "model", "model", g_list_store_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/storage/storage-graph.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY, usage_storage_graph_properties[USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY] = g_param_spec_uint ("min-percentage-shown-files", "min-percentage-shown-files", "min-percentage-shown-files", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1236 "storage-graph.c"
}

static void
usage_storage_graph_instance_init (UsageStorageGraph * self,
                                   gpointer klass)
{
#line 25 "../src/storage/storage-graph.vala"
	self->priv = usage_storage_graph_get_instance_private (self);
#line 29 "../src/storage/storage-graph.vala"
	self->priv->selected_size = (guint64) 0;
#line 1247 "storage-graph.c"
}

static void
usage_storage_graph_finalize (GObject * obj)
{
	UsageStorageGraph * self;
#line 25 "../src/storage/storage-graph.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph);
#line 25 "../src/storage/storage-graph.vala"
	G_OBJECT_CLASS (usage_storage_graph_parent_class)->finalize (obj);
#line 1258 "storage-graph.c"
}

static GType
usage_storage_graph_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageStorageGraphClass), (GBaseInitFunc) usage_storage_graph_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_storage_graph_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageStorageGraph), 0, (GInstanceInitFunc) usage_storage_graph_instance_init, NULL };
	GType usage_storage_graph_type_id;
	usage_storage_graph_type_id = g_type_register_static (gtk_drawing_area_get_type (), "UsageStorageGraph", &g_define_type_info, 0);
	UsageStorageGraph_private_offset = g_type_add_instance_private (usage_storage_graph_type_id, sizeof (UsageStorageGraphPrivate));
	return usage_storage_graph_type_id;
}

GType
usage_storage_graph_get_type (void)
{
	static volatile gsize usage_storage_graph_type_id__once = 0;
	if (g_once_init_enter (&usage_storage_graph_type_id__once)) {
		GType usage_storage_graph_type_id;
		usage_storage_graph_type_id = usage_storage_graph_get_type_once ();
		g_once_init_leave (&usage_storage_graph_type_id__once, usage_storage_graph_type_id);
	}
	return usage_storage_graph_type_id__once;
}

static void
_vala_usage_storage_graph_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	UsageStorageGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph);
#line 25 "../src/storage/storage-graph.vala"
	switch (property_id) {
#line 25 "../src/storage/storage-graph.vala"
		case USAGE_STORAGE_GRAPH_MODEL_PROPERTY:
#line 25 "../src/storage/storage-graph.vala"
		g_value_set_object (value, usage_storage_graph_get_model (self));
#line 25 "../src/storage/storage-graph.vala"
		break;
#line 25 "../src/storage/storage-graph.vala"
		case USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY:
#line 25 "../src/storage/storage-graph.vala"
		g_value_set_uint (value, usage_storage_graph_get_min_percentage_shown_files (self));
#line 25 "../src/storage/storage-graph.vala"
		break;
#line 1305 "storage-graph.c"
		default:
#line 25 "../src/storage/storage-graph.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/storage/storage-graph.vala"
		break;
#line 1311 "storage-graph.c"
	}
}

static void
_vala_usage_storage_graph_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	UsageStorageGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_GRAPH, UsageStorageGraph);
#line 25 "../src/storage/storage-graph.vala"
	switch (property_id) {
#line 25 "../src/storage/storage-graph.vala"
		case USAGE_STORAGE_GRAPH_MODEL_PROPERTY:
#line 25 "../src/storage/storage-graph.vala"
		usage_storage_graph_set_model (self, g_value_get_object (value));
#line 25 "../src/storage/storage-graph.vala"
		break;
#line 25 "../src/storage/storage-graph.vala"
		case USAGE_STORAGE_GRAPH_MIN_PERCENTAGE_SHOWN_FILES_PROPERTY:
#line 25 "../src/storage/storage-graph.vala"
		usage_storage_graph_set_min_percentage_shown_files (self, g_value_get_uint (value));
#line 25 "../src/storage/storage-graph.vala"
		break;
#line 1337 "storage-graph.c"
		default:
#line 25 "../src/storage/storage-graph.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/storage/storage-graph.vala"
		break;
#line 1343 "storage-graph.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

