/* storage-view-item.c generated by valac 0.56.3, the Vala compiler
 * generated from storage-view-item.vala, do not modify */

/* storage-view-item.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Felipe Borges <felipeborges@gnome.org>
 *          Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	STORAGE_VIEW_TYPE_NONE,
	STORAGE_VIEW_TYPE_OS,
	STORAGE_VIEW_TYPE_UP_FOLDER,
	STORAGE_VIEW_TYPE_AVAILABLE_GRAPH,
	STORAGE_VIEW_TYPE_ROOT_ITEM
} StorageViewType;

#define TYPE_STORAGE_VIEW_TYPE (storage_view_type_get_type ())

#define USAGE_TYPE_STORAGE_VIEW_ITEM (usage_storage_view_item_get_type ())
#define USAGE_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem))
#define USAGE_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))
#define USAGE_IS_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_IS_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_STORAGE_VIEW_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))

typedef struct _UsageStorageViewItem UsageStorageViewItem;
typedef struct _UsageStorageViewItemClass UsageStorageViewItemClass;
typedef struct _UsageStorageViewItemPrivate UsageStorageViewItemPrivate;
enum  {
	USAGE_STORAGE_VIEW_ITEM_0_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_NUM_PROPERTIES
};
static GParamSpec* usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UsageStorageViewItem {
	GObject parent_instance;
	UsageStorageViewItemPrivate * priv;
	gchar* uri;
	gchar* name;
	guint64 size;
	GFileType type;
	GUserDirectory* dir;
	gchar* ontology;
	StorageViewType custom_type;
};

struct _UsageStorageViewItemClass {
	GObjectClass parent_class;
};

struct _UsageStorageViewItemPrivate {
	gdouble _percentage;
	gboolean _loaded;
	GdkRGBA _color;
	gchar* _style_class;
};

static gint UsageStorageViewItem_private_offset;
static gpointer usage_storage_view_item_parent_class = NULL;

VALA_EXTERN GType storage_view_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType usage_storage_view_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageStorageViewItem, g_object_unref)
VALA_EXTERN UsageStorageViewItem* usage_storage_view_item_from_file (GFile* file);
VALA_EXTERN UsageStorageViewItem* usage_storage_view_item_new (void);
VALA_EXTERN UsageStorageViewItem* usage_storage_view_item_construct (GType object_type);
static void usage_storage_view_item_setup_tag_style (UsageStorageViewItem* self);
VALA_EXTERN void usage_storage_view_item_set_style_class (UsageStorageViewItem* self,
                                              const gchar* value);
static gboolean _usage_storage_view_item_show_check_button (UsageStorageViewItem* self);
VALA_EXTERN gdouble usage_storage_view_item_get_percentage (UsageStorageViewItem* self);
VALA_EXTERN void usage_storage_view_item_set_percentage (UsageStorageViewItem* self,
                                             gdouble value);
VALA_EXTERN gboolean usage_storage_view_item_get_loaded (UsageStorageViewItem* self);
VALA_EXTERN void usage_storage_view_item_set_loaded (UsageStorageViewItem* self,
                                         gboolean value);
VALA_EXTERN void usage_storage_view_item_get_color (UsageStorageViewItem* self,
                                        GdkRGBA * result);
VALA_EXTERN void usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                        GdkRGBA * value);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
VALA_EXTERN const gchar* usage_storage_view_item_get_style_class (UsageStorageViewItem* self);
VALA_EXTERN gboolean usage_storage_view_item_get_show_check_button (UsageStorageViewItem* self);
static void usage_storage_view_item_finalize (GObject * obj);
static GType usage_storage_view_item_get_type_once (void);
static void _vala_usage_storage_view_item_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_usage_storage_view_item_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
storage_view_type_get_type_once (void)
{
	static const GEnumValue values[] = {{STORAGE_VIEW_TYPE_NONE, "STORAGE_VIEW_TYPE_NONE", "none"}, {STORAGE_VIEW_TYPE_OS, "STORAGE_VIEW_TYPE_OS", "os"}, {STORAGE_VIEW_TYPE_UP_FOLDER, "STORAGE_VIEW_TYPE_UP_FOLDER", "up-folder"}, {STORAGE_VIEW_TYPE_AVAILABLE_GRAPH, "STORAGE_VIEW_TYPE_AVAILABLE_GRAPH", "available-graph"}, {STORAGE_VIEW_TYPE_ROOT_ITEM, "STORAGE_VIEW_TYPE_ROOT_ITEM", "root-item"}, {0, NULL, NULL}};
	GType storage_view_type_type_id;
	storage_view_type_type_id = g_enum_register_static ("StorageViewType", values);
	return storage_view_type_type_id;
}

GType
storage_view_type_get_type (void)
{
	static volatile gsize storage_view_type_type_id__once = 0;
	if (g_once_init_enter (&storage_view_type_type_id__once)) {
		GType storage_view_type_type_id;
		storage_view_type_type_id = storage_view_type_get_type_once ();
		g_once_init_leave (&storage_view_type_type_id__once, storage_view_type_type_id);
	}
	return storage_view_type_type_id__once;
}

static inline gpointer
usage_storage_view_item_get_instance_private (UsageStorageViewItem* self)
{
	return G_STRUCT_MEMBER_P (self, UsageStorageViewItem_private_offset);
}

UsageStorageViewItem*
usage_storage_view_item_from_file (GFile* file)
{
	UsageStorageViewItem* item = NULL;
	UsageStorageViewItem* _tmp0_;
	UsageStorageViewItem* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	UsageStorageViewItem* result;
#line 65 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 66 "../src/storage/storage-view-item.vala"
	_tmp0_ = usage_storage_view_item_new ();
#line 66 "../src/storage/storage-view-item.vala"
	item = _tmp0_;
#line 67 "../src/storage/storage-view-item.vala"
	_tmp1_ = item;
#line 67 "../src/storage/storage-view-item.vala"
	_tmp2_ = g_file_get_uri (file);
#line 67 "../src/storage/storage-view-item.vala"
	_g_free0 (_tmp1_->uri);
#line 67 "../src/storage/storage-view-item.vala"
	_tmp1_->uri = _tmp2_;
#line 191 "storage-view-item.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp3_;
		UsageStorageViewItem* _tmp4_;
		GFileInfo* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		UsageStorageViewItem* _tmp8_;
		GFileInfo* _tmp9_;
		UsageStorageViewItem* _tmp10_;
		GFileInfo* _tmp11_;
#line 70 "../src/storage/storage-view-item.vala"
		_tmp3_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_TRASH_ORIG_PATH, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 70 "../src/storage/storage-view-item.vala"
		info = _tmp3_;
#line 70 "../src/storage/storage-view-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "storage-view-item.c"
			goto __catch0_g_error;
		}
#line 72 "../src/storage/storage-view-item.vala"
		_tmp4_ = item;
#line 72 "../src/storage/storage-view-item.vala"
		_tmp5_ = info;
#line 72 "../src/storage/storage-view-item.vala"
		_tmp6_ = g_file_info_get_name (_tmp5_);
#line 72 "../src/storage/storage-view-item.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 72 "../src/storage/storage-view-item.vala"
		_g_free0 (_tmp4_->name);
#line 72 "../src/storage/storage-view-item.vala"
		_tmp4_->name = _tmp7_;
#line 73 "../src/storage/storage-view-item.vala"
		_tmp8_ = item;
#line 73 "../src/storage/storage-view-item.vala"
		_tmp9_ = info;
#line 73 "../src/storage/storage-view-item.vala"
		_tmp8_->size = (guint64) g_file_info_get_size (_tmp9_);
#line 74 "../src/storage/storage-view-item.vala"
		_tmp10_ = item;
#line 74 "../src/storage/storage-view-item.vala"
		_tmp11_ = info;
#line 74 "../src/storage/storage-view-item.vala"
		_tmp10_->type = g_file_info_get_file_type (_tmp11_);
#line 69 "../src/storage/storage-view-item.vala"
		_g_object_unref0 (info);
#line 238 "storage-view-item.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 69 "../src/storage/storage-view-item.vala"
		g_clear_error (&_inner_error0_);
#line 76 "../src/storage/storage-view-item.vala"
		result = NULL;
#line 76 "../src/storage/storage-view-item.vala"
		_g_object_unref0 (item);
#line 76 "../src/storage/storage-view-item.vala"
		return result;
#line 251 "storage-view-item.c"
	}
	__finally0:
#line 69 "../src/storage/storage-view-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/storage/storage-view-item.vala"
		_g_object_unref0 (item);
#line 69 "../src/storage/storage-view-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/storage/storage-view-item.vala"
		g_clear_error (&_inner_error0_);
#line 69 "../src/storage/storage-view-item.vala"
		return NULL;
#line 264 "storage-view-item.c"
	}
#line 79 "../src/storage/storage-view-item.vala"
	result = item;
#line 79 "../src/storage/storage-view-item.vala"
	return result;
#line 270 "storage-view-item.c"
}

static void
usage_storage_view_item_setup_tag_style (UsageStorageViewItem* self)
{
	GUserDirectory* _tmp0_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label0 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label1 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label2 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label3 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label4 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label5 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label6 = 0;
#line 294 "storage-view-item.c"
	const gchar* _tmp6_;
#line 82 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/storage/storage-view-item.vala"
	if (self->type == G_FILE_TYPE_DIRECTORY) {
#line 84 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_style_class (self, "folders");
#line 302 "storage-view-item.c"
	}
#line 87 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->dir;
#line 87 "../src/storage/storage-view-item.vala"
	if (_tmp0_ != NULL) {
#line 308 "storage-view-item.c"
		GUserDirectory* _tmp1_;
#line 88 "../src/storage/storage-view-item.vala"
		_tmp1_ = self->dir;
#line 88 "../src/storage/storage-view-item.vala"
		switch (*_tmp1_) {
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_PICTURES:
#line 316 "storage-view-item.c"
			{
#line 90 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "pictures");
#line 91 "../src/storage/storage-view-item.vala"
				break;
#line 322 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_VIDEOS:
#line 326 "storage-view-item.c"
			{
#line 93 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "videos");
#line 94 "../src/storage/storage-view-item.vala"
				break;
#line 332 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOCUMENTS:
#line 336 "storage-view-item.c"
			{
#line 96 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "documents");
#line 97 "../src/storage/storage-view-item.vala"
				break;
#line 342 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_MUSIC:
#line 346 "storage-view-item.c"
			{
#line 99 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "music");
#line 100 "../src/storage/storage-view-item.vala"
				break;
#line 352 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOWNLOAD:
#line 356 "storage-view-item.c"
			{
#line 102 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "downloads");
#line 103 "../src/storage/storage-view-item.vala"
				break;
#line 362 "storage-view-item.c"
			}
			default:
#line 88 "../src/storage/storage-view-item.vala"
			break;
#line 367 "storage-view-item.c"
		}
	}
#line 107 "../src/storage/storage-view-item.vala"
	_tmp2_ = self->ontology;
#line 107 "../src/storage/storage-view-item.vala"
	_tmp3_ = _tmp2_;
#line 107 "../src/storage/storage-view-item.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 107 "../src/storage/storage-view-item.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("nmm#MusicPiece")))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 380 "storage-view-item.c"
			default:
			{
#line 109 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "music");
#line 110 "../src/storage/storage-view-item.vala"
				break;
#line 387 "storage-view-item.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("nmm#Photo")))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 393 "storage-view-item.c"
			default:
			{
#line 112 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "pictures");
#line 113 "../src/storage/storage-view-item.vala"
				break;
#line 400 "storage-view-item.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("nmm#Video")))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 406 "storage-view-item.c"
			default:
			{
#line 115 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "videos");
#line 116 "../src/storage/storage-view-item.vala"
				break;
#line 413 "storage-view-item.c"
			}
		}
	} else if ((((_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("nfo#PaginatedTextDocument")))) || (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("nfo#PlainTextDocument"))))) || (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("nfo#FileDataObject"))))) || (_tmp5_ == ((0 != _tmp4_label6) ? _tmp4_label6 : (_tmp4_label6 = g_quark_from_static_string ("nfo#EBook"))))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 419 "storage-view-item.c"
			default:
			{
#line 121 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "documents");
#line 122 "../src/storage/storage-view-item.vala"
				break;
#line 426 "storage-view-item.c"
			}
		}
	}
#line 125 "../src/storage/storage-view-item.vala"
	if (self->custom_type != STORAGE_VIEW_TYPE_NONE) {
#line 126 "../src/storage/storage-view-item.vala"
		switch (self->custom_type) {
#line 126 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_OS:
#line 436 "storage-view-item.c"
			{
#line 128 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "os-tag");
#line 129 "../src/storage/storage-view-item.vala"
				break;
#line 442 "storage-view-item.c"
			}
#line 126 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_AVAILABLE_GRAPH:
#line 446 "storage-view-item.c"
			{
#line 131 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "available-tag");
#line 132 "../src/storage/storage-view-item.vala"
				break;
#line 452 "storage-view-item.c"
			}
			default:
#line 126 "../src/storage/storage-view-item.vala"
			break;
#line 457 "storage-view-item.c"
		}
	}
#line 136 "../src/storage/storage-view-item.vala"
	_tmp6_ = self->priv->_style_class;
#line 136 "../src/storage/storage-view-item.vala"
	if (_tmp6_ == NULL) {
#line 137 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_style_class (self, "files");
#line 466 "storage-view-item.c"
	}
}

static gboolean
_usage_storage_view_item_show_check_button (UsageStorageViewItem* self)
{
	GUserDirectory* _tmp0_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label0 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label1 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label2 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label3 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label4 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label5 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp4_label6 = 0;
#line 491 "storage-view-item.c"
	gboolean result;
#line 140 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 141 "../src/storage/storage-view-item.vala"
	if (self->custom_type != STORAGE_VIEW_TYPE_NONE) {
#line 142 "../src/storage/storage-view-item.vala"
		switch (self->custom_type) {
#line 142 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_OS:
#line 142 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_AVAILABLE_GRAPH:
#line 142 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_UP_FOLDER:
#line 505 "storage-view-item.c"
			{
#line 146 "../src/storage/storage-view-item.vala"
				result = FALSE;
#line 146 "../src/storage/storage-view-item.vala"
				return result;
#line 511 "storage-view-item.c"
			}
			default:
#line 142 "../src/storage/storage-view-item.vala"
			break;
#line 516 "storage-view-item.c"
		}
	}
#line 150 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->dir;
#line 150 "../src/storage/storage-view-item.vala"
	if (_tmp0_ != NULL) {
#line 523 "storage-view-item.c"
		GUserDirectory* _tmp1_;
#line 151 "../src/storage/storage-view-item.vala"
		_tmp1_ = self->dir;
#line 151 "../src/storage/storage-view-item.vala"
		switch (*_tmp1_) {
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_PICTURES:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_VIDEOS:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOCUMENTS:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_MUSIC:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOWNLOAD:
#line 539 "storage-view-item.c"
			{
#line 157 "../src/storage/storage-view-item.vala"
				result = TRUE;
#line 157 "../src/storage/storage-view-item.vala"
				return result;
#line 545 "storage-view-item.c"
			}
			default:
#line 151 "../src/storage/storage-view-item.vala"
			break;
#line 550 "storage-view-item.c"
		}
	}
#line 161 "../src/storage/storage-view-item.vala"
	_tmp2_ = self->ontology;
#line 161 "../src/storage/storage-view-item.vala"
	_tmp3_ = _tmp2_;
#line 161 "../src/storage/storage-view-item.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 161 "../src/storage/storage-view-item.vala"
	if (((((((_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("nmm#MusicPiece")))) || (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("nmm#Photo"))))) || (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("nmm#Video"))))) || (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("nfo#PaginatedTextDocument"))))) || (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("nfo#PlainTextDocument"))))) || (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("nfo#FileDataObject"))))) || (_tmp5_ == ((0 != _tmp4_label6) ? _tmp4_label6 : (_tmp4_label6 = g_quark_from_static_string ("nfo#EBook"))))) {
#line 161 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 563 "storage-view-item.c"
			default:
			{
#line 169 "../src/storage/storage-view-item.vala"
				result = TRUE;
#line 169 "../src/storage/storage-view-item.vala"
				return result;
#line 570 "storage-view-item.c"
			}
		}
	}
#line 172 "../src/storage/storage-view-item.vala"
	result = FALSE;
#line 172 "../src/storage/storage-view-item.vala"
	return result;
#line 578 "storage-view-item.c"
}

UsageStorageViewItem*
usage_storage_view_item_construct (GType object_type)
{
	UsageStorageViewItem * self = NULL;
#line 30 "../src/storage/storage-view-item.vala"
	self = (UsageStorageViewItem*) g_object_new (object_type, NULL);
#line 30 "../src/storage/storage-view-item.vala"
	return self;
#line 589 "storage-view-item.c"
}

UsageStorageViewItem*
usage_storage_view_item_new (void)
{
#line 30 "../src/storage/storage-view-item.vala"
	return usage_storage_view_item_construct (USAGE_TYPE_STORAGE_VIEW_ITEM);
#line 597 "storage-view-item.c"
}

gdouble
usage_storage_view_item_get_percentage (UsageStorageViewItem* self)
{
	gdouble result;
#line 31 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 31 "../src/storage/storage-view-item.vala"
	result = self->priv->_percentage;
#line 31 "../src/storage/storage-view-item.vala"
	return result;
#line 610 "storage-view-item.c"
}

void
usage_storage_view_item_set_percentage (UsageStorageViewItem* self,
                                        gdouble value)
{
	gdouble old_value;
#line 31 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/storage/storage-view-item.vala"
	old_value = usage_storage_view_item_get_percentage (self);
#line 31 "../src/storage/storage-view-item.vala"
	if (old_value != value) {
#line 31 "../src/storage/storage-view-item.vala"
		self->priv->_percentage = value;
#line 31 "../src/storage/storage-view-item.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY]);
#line 628 "storage-view-item.c"
	}
}

gboolean
usage_storage_view_item_get_loaded (UsageStorageViewItem* self)
{
	gboolean result;
#line 32 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/storage/storage-view-item.vala"
	result = self->priv->_loaded;
#line 32 "../src/storage/storage-view-item.vala"
	return result;
#line 642 "storage-view-item.c"
}

void
usage_storage_view_item_set_loaded (UsageStorageViewItem* self,
                                    gboolean value)
{
	gboolean old_value;
#line 32 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/storage/storage-view-item.vala"
	old_value = usage_storage_view_item_get_loaded (self);
#line 32 "../src/storage/storage-view-item.vala"
	if (old_value != value) {
#line 32 "../src/storage/storage-view-item.vala"
		self->priv->_loaded = value;
#line 32 "../src/storage/storage-view-item.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY]);
#line 660 "storage-view-item.c"
	}
}

void
usage_storage_view_item_get_color (UsageStorageViewItem* self,
                                   GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->priv->_color;
#line 33 "../src/storage/storage-view-item.vala"
	*result = _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
	return;
#line 677 "storage-view-item.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 33 "../src/storage/storage-view-item.vala"
	if (s1 == s2) {
#line 33 "../src/storage/storage-view-item.vala"
		return TRUE;
#line 688 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1 == NULL) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 694 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s2 == NULL) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 700 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->red != s2->red) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 706 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->green != s2->green) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 712 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->blue != s2->blue) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 718 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->alpha != s2->alpha) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 724 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	return TRUE;
#line 728 "storage-view-item.c"
}

void
usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                   GdkRGBA * value)
{
	GdkRGBA old_value;
#line 33 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/storage/storage-view-item.vala"
	usage_storage_view_item_get_color (self, &old_value);
#line 33 "../src/storage/storage-view-item.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 742 "storage-view-item.c"
		GdkRGBA _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
		_tmp0_ = *value;
#line 33 "../src/storage/storage-view-item.vala"
		self->priv->_color = _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY]);
#line 750 "storage-view-item.c"
	}
}

const gchar*
usage_storage_view_item_get_style_class (UsageStorageViewItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp2_;
#line 49 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->priv->_style_class;
#line 50 "../src/storage/storage-view-item.vala"
	if (_tmp0_ != NULL) {
#line 766 "storage-view-item.c"
		const gchar* _tmp1_;
#line 51 "../src/storage/storage-view-item.vala"
		_tmp1_ = self->priv->_style_class;
#line 51 "../src/storage/storage-view-item.vala"
		result = _tmp1_;
#line 51 "../src/storage/storage-view-item.vala"
		return result;
#line 774 "storage-view-item.c"
	}
#line 53 "../src/storage/storage-view-item.vala"
	usage_storage_view_item_setup_tag_style (self);
#line 55 "../src/storage/storage-view-item.vala"
	_tmp2_ = self->priv->_style_class;
#line 55 "../src/storage/storage-view-item.vala"
	result = _tmp2_;
#line 55 "../src/storage/storage-view-item.vala"
	return result;
#line 784 "storage-view-item.c"
}

void
usage_storage_view_item_set_style_class (UsageStorageViewItem* self,
                                         const gchar* value)
{
	gchar* _tmp0_;
#line 46 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/storage/storage-view-item.vala"
	_tmp0_ = g_strdup (value);
#line 47 "../src/storage/storage-view-item.vala"
	_g_free0 (self->priv->_style_class);
#line 47 "../src/storage/storage-view-item.vala"
	self->priv->_style_class = _tmp0_;
#line 46 "../src/storage/storage-view-item.vala"
	g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY]);
#line 802 "storage-view-item.c"
}

gboolean
usage_storage_view_item_get_show_check_button (UsageStorageViewItem* self)
{
	gboolean result;
#line 60 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/storage/storage-view-item.vala"
	result = _usage_storage_view_item_show_check_button (self);
#line 61 "../src/storage/storage-view-item.vala"
	return result;
#line 815 "storage-view-item.c"
}

static void
usage_storage_view_item_class_init (UsageStorageViewItemClass * klass,
                                    gpointer klass_data)
{
#line 30 "../src/storage/storage-view-item.vala"
	usage_storage_view_item_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/storage/storage-view-item.vala"
	g_type_class_adjust_private_offset (klass, &UsageStorageViewItem_private_offset);
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_storage_view_item_get_property;
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_storage_view_item_set_property;
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_storage_view_item_finalize;
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "percentage", "percentage", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY] = g_param_spec_boolean ("loaded", "loaded", "loaded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY] = g_param_spec_boxed ("color", "color", "color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY] = g_param_spec_string ("style-class", "style-class", "style-class", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY] = g_param_spec_boolean ("show-check-button", "show-check-button", "show-check-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 842 "storage-view-item.c"
}

static void
usage_storage_view_item_instance_init (UsageStorageViewItem * self,
                                       gpointer klass)
{
#line 30 "../src/storage/storage-view-item.vala"
	self->priv = usage_storage_view_item_get_instance_private (self);
#line 32 "../src/storage/storage-view-item.vala"
	self->priv->_loaded = FALSE;
#line 42 "../src/storage/storage-view-item.vala"
	self->custom_type = STORAGE_VIEW_TYPE_NONE;
#line 44 "../src/storage/storage-view-item.vala"
	self->priv->_style_class = NULL;
#line 857 "storage-view-item.c"
}

static void
usage_storage_view_item_finalize (GObject * obj)
{
	UsageStorageViewItem * self;
#line 30 "../src/storage/storage-view-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
#line 35 "../src/storage/storage-view-item.vala"
	_g_free0 (self->uri);
#line 36 "../src/storage/storage-view-item.vala"
	_g_free0 (self->name);
#line 40 "../src/storage/storage-view-item.vala"
	_g_free0 (self->dir);
#line 41 "../src/storage/storage-view-item.vala"
	_g_free0 (self->ontology);
#line 44 "../src/storage/storage-view-item.vala"
	_g_free0 (self->priv->_style_class);
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (usage_storage_view_item_parent_class)->finalize (obj);
#line 878 "storage-view-item.c"
}

static GType
usage_storage_view_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageStorageViewItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_storage_view_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageStorageViewItem), 0, (GInstanceInitFunc) usage_storage_view_item_instance_init, NULL };
	GType usage_storage_view_item_type_id;
	usage_storage_view_item_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageStorageViewItem", &g_define_type_info, 0);
	UsageStorageViewItem_private_offset = g_type_add_instance_private (usage_storage_view_item_type_id, sizeof (UsageStorageViewItemPrivate));
	return usage_storage_view_item_type_id;
}

GType
usage_storage_view_item_get_type (void)
{
	static volatile gsize usage_storage_view_item_type_id__once = 0;
	if (g_once_init_enter (&usage_storage_view_item_type_id__once)) {
		GType usage_storage_view_item_type_id;
		usage_storage_view_item_type_id = usage_storage_view_item_get_type_once ();
		g_once_init_leave (&usage_storage_view_item_type_id__once, usage_storage_view_item_type_id);
	}
	return usage_storage_view_item_type_id__once;
}

static void
_vala_usage_storage_view_item_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	UsageStorageViewItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
#line 30 "../src/storage/storage-view-item.vala"
	switch (property_id) {
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_double (value, usage_storage_view_item_get_percentage (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_boolean (value, usage_storage_view_item_get_loaded (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY:
#line 927 "storage-view-item.c"
		{
			GdkRGBA boxed;
#line 30 "../src/storage/storage-view-item.vala"
			usage_storage_view_item_get_color (self, &boxed);
#line 30 "../src/storage/storage-view-item.vala"
			g_value_set_boxed (value, &boxed);
#line 934 "storage-view-item.c"
		}
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_string (value, usage_storage_view_item_get_style_class (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_boolean (value, usage_storage_view_item_get_show_check_button (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 950 "storage-view-item.c"
		default:
#line 30 "../src/storage/storage-view-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 956 "storage-view-item.c"
	}
}

static void
_vala_usage_storage_view_item_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	UsageStorageViewItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
#line 30 "../src/storage/storage-view-item.vala"
	switch (property_id) {
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_percentage (self, g_value_get_double (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_loaded (self, g_value_get_boolean (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_color (self, g_value_get_boxed (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_style_class (self, g_value_get_string (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 994 "storage-view-item.c"
		default:
#line 30 "../src/storage/storage-view-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 1000 "storage-view-item.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

